/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has any use.
 *
 */

#import <appkit/appkit.h>

@interface LCAUView:View {

	id		aSwitch;
	id		gridSize;
	id		ruleNumber;
	id		pswit;
	id		tiDat;

	id		genEv;

	id		theEvolView;
	id		theShEvolView;
	id		theThEvolView;

	id		evolWindow;
	id		keyWindow;
	id		shEvolWindow;
	id		thEvolWindow;
	
	id		menuCopy;
	id		menuPrint;

	id		keepTop;
	id		delegate;
	id		crossCursor;
}

- copyEvolu:sender;
- copyShEvol:sender;
- copyThEvol:sender;
- drawEvolu:sender;
- drawShEvol:sender;
- drawThEvol:sender;
- printEvolu:sender;
- printShEvol:sender;
- printThEvol:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end LCAUView.h */
