
/* 
 * LCAUView.m -- Implementation file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, or even that it has a use.
 *
 */

#import "LCAUView.h"
#import "nxlcau32.h"
#import "nxardn3h.h"
#import <math.h> 
#import <stdio.h>
#import <stdlib.h>
#import <string.h>

extern char ascrule[KK][KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK][KK];

int    drawBack=YES;
int    drawEvol=NO;
int    drawPlanne=NO;
int    drawShort=NO;
int    drawThird=NO;

int    drawview=0;

int    repPlEv=1;

extern NXColor colst[KK];

extern double blpr[KK];			/* probability from blocks	*/

extern int    co, dn;			/* connectivity, dimension  */
extern char   arr1[], arr2[];
extern float  getNumber(NXStream *stream);
extern int    getSeparator(NXStream *stream);


void     shortevolve(int m, int n);
void     nxlcau32();
void     wru();


@implementation LCAUView

void videocursor(p,i,j) int p, i, j; {}
void videoputc(c,i) char c; int i; {}
void videomode(i) int i; {}
void videopalette(i) int i; {}
void videoscroll(i,j,k,l,d,c) int i, j, k, l, d, c; {}
void videocattr(p,c,n,l) int p, c, n, l; {}


void videodot(i,j,l) int i, j, l; {
  if (l<3) NXSetColor(colst[l]); else NXSetColor(NX_COLORORANGE);
    switch (drawview) {
      case 0: PSrectfill(2.0*(float)j,398.0-2.0*(float)i,1.25,1.25); break;
      case 1: PSrectfill(2.0*(float)i,398.0-2.0*(float)j,1.25,1.25); break;
      case 2: PSrectfill(8.0*(float)j+1.5,60.0-8.0*(float)i,4.75,4.75); break;
      case 3: PSrectfill(4.0*(float)j+2.0,48.0-4.0*(float)i,3.0,3.0); break;
      case 4: PSrectfill(2.0*(float)j,100.0-2.0*(float)i,1.25,1.25); break;
      case 5: PSrectfill(2.0*(float)j,2.0*(float)i,1.5,1.5); break;
      case 6: PSrectfill(10.0*(float)j,10.0*(float)i,9.0,9.0); break;
      case 7: PSrectfill(4.0*(float)j,4.0*(float)i,3.125,3.125); break;
      case 8:  PSrectfill(150.0+(float)j,260.0-(float)i,1.0,1.0); break;
      case 9:  PSrectfill(2.0*(float)j,173.0-2.0*(float)i,1.5,1.5); break;
      case 10: PSrectfill((float)j,(float)i,3.125,3.125); break;
      case 11: PSrectfill((float)j,(float)i,1.0,1.0); break;
      case 12: PSrectfill(2.0*(float)j,100.0-2.0*(float)i,1.25,1.25); break;
      case 13: PSrectfill(2.0*(float)j,251.0-2.0*(float)i,1.25,1.25); break;
      default: break;}
      

}

/* m = line length; n = number of lines */

void shortevolve(m,n) int m, n; {int i, j, o;
  savearry();
  asctobin();
  o=YL/2-m/2;
  for (j=0; j<n; j++) {
    for (i=0; i<m; i++) videodot(j,i,arr1[i+o]);
    onegen(AL);
    }
  renewarry();
}

void tcolordot(p,c) double p[3], c[3]; {double s;
  s=1.0/(p[0]+p[1]+p[2]);
  PSsetcmykcolor(c[0],c[1],c[2],0.0);
  PSrectfill(200.0*(p[1]+0.5*p[2])*s,173.0-200.0*p[2]*s*0.866,1.5,1.5);
}

void drawsquarre() {int i, j;
  for (i=0; i<128; i++) for (j=0; j<128; j++) videodot(j,i,arr1[i*128+j]);
}

void drawcubbe() {int i, j, k;
  for (i=0; i<32; i++) for (j=0; j<32; j++) for (k=0; k<16; k++) 
    videodot(j+32*(k/4),i+32*(k%4),arr1[ix3(i,j,k)]);
}

void drawgryd() {int i;
	  PSsetgray(NX_BLACK); 
	  PSsetlinewidth(0.1);
  for (i=0; i<5; i++) {
  PSmoveto((double)(128.0*i),0.0); PSlineto((double)(128.0*i),512.0);}
  for (i=0; i<5; i++) {
  PSmoveto(0.0,(double)(128.0*i)); PSlineto(512.0,(double)(128.0*i));}
  PSstroke();
}

/* --------------------------- E V O L U T I O N --------------------------- */

- drawEvolu:sender {
  drawview=0;
  drawEvol=YES;
  [self display];
  drawEvol=NO;
return self;
}

- printEvolu:sender {
  drawview=1;
  drawEvol=YES;
    [keyWindow smartPrintPSCode: self];
  drawEvol=NO;
return self;
}

- drawShEvol:sender {
    drawview=7;
    drawShort=YES;
    [self display];
    drawShort=NO;
return self;
}

- printShEvol:sender {
    drawview=7;
    drawShort=YES;
    [keyWindow smartPrintPSCode: self];
    drawShort=NO;
return self;
}

- drawThEvol:sender {
    [thEvolWindow makeKeyAndOrderFront: self];
    drawview=6;
    drawThird=YES;
    [thEvolWindow display];
    drawThird=NO;
return self;
}

- printThEvol:sender {
    drawview=6;
    drawThird=YES;
    [keyWindow smartPrintPSCode: self];
    drawThird=NO;
return self;
}

- drawPlEvol:sender {int i;
  repPlEv=[[sender selectedCell] tag];
  drawview=7;
  drawPlanne=YES;
  asctobin();
  for (i=0; i<repPlEv; i++) {
    [genEv setIntValue: i];
     onegen(AL);
     [self display];
     }
  [genEv setIntValue: repPlEv];
  drawPlanne=NO;
return self;
}

- printPlEvol:sender {
    repPlEv=0;
    drawview=7;
    drawPlanne=YES;
    [keyWindow smartPrintPSCode: self];
    drawPlanne=NO;

return self;
}

- printLCAU:sender {
    if (keyWindow==evolWindow)    [self printEvolu:   sender];
    if (keyWindow==shEvolWindow)  [self printShEvol:  sender];
    if (keyWindow==thEvolWindow)  [self printThEvol:  sender];
return self;
}

- windowDidBecomeKey:sender {
	keyWindow=sender;
	[menuCopy setTarget: self];
	[menuCopy setAction: @selector(copyLCAU:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: self];
	[menuPrint setAction: @selector(printLCAU:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
	[menuCopy setEnabled: NO];
	[menuPrint setEnabled: NO];
return self;
}

- copyShEvol:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyEvolu:sender {
NXRect zbounds;
id     pBoard;
  drawview=7;
  drawShort=YES;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [theShEvolView getBounds: &zbounds];
  [theShEvolView writePSCodeInside: &zbounds to: pBoard]; 
  drawShort=NO;
return self;
}

- copyLCAU:sender {
    if (keyWindow==evolWindow)    [self copyEvolu:  sender];
    if (keyWindow==shEvolWindow)  [self copyShEvol: sender];
    if (keyWindow==thEvolWindow)  [self copythEvol: sender];
return self;
}

/* -------------------------------- L C A U -------------------------------- */

// - showLine:sender {int i;
// for (i=0; i<AL; i++) [[lineButtons cellAt:i/32:i%32] setIntValue:arr1[i]];
// return self; }


/* -------------------------------- R I J N -------------------------------- */

/* -------------------------------- P R O B -------------------------------- */

/* -------------------------------- * * * * -------------------------------- */


- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LCAUView object.  First, an initFrame: message is sent 
 * to super to initialize LCAUView as a View.  Next, the LCAUView sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	
	[super initFrame:frameRect];
/*	[self translate:floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	crossCursor = 
		[NXCursor newFromImage:[NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];

  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);


  [self setFlipped: YES];

	return self;

}


- setDelegate:anObject
/*
 * Sets the LCAUView's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LCAUView's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LCAUView only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[WNML];
	int		 i, j, k, n;
	int		 ii, jj, bas, nn;
        double           p, q, s, dp, pee, cue;
	double		 aa[KK], bb[KK], cc[KK], cq[KK];
	double		 en;
	NXPoint		 *aPoint;
	NXRect		 plotRect;

	
	if (rects == NULL) return self;

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	if (drawBack) NXRectFill(&rects[0]);
	PSsetgray(NX_DKGRAY);

// drawAxes(bounds.origin.x, bounds.origin.y, bounds.size.width, bounds.size.height);


        if (drawEvol==YES) {
//          sprintf(c,"Rule %12u",wru());
//          [ruleNumber setStringValue: c];
	  evolve(0);
	  }

        if (drawShort==YES) {
//          sprintf(c,"Rule %12u",wru());
//         [ruleNumber setStringValue: c];
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/4.0);
	  j=(int)(plotRect.size.height/4.0);
	  shortevolve(i,j);
	}

        if (drawPlanne==YES) {
   wru(c);
   [ruleNumber setStringValue: c];
   switch (dn) {
     case 2: 
	[window setTitle: "(3,1) von Neumann Plane Evolution"];
	drawsquarre();
	break;
     case 3: 
	[window setTitle: "3-D solid tetrahedron"];
	drawcubbe();
	drawgryd();
	break;
     case 4: 
	[window setTitle: "4-D 1 cell per dimension with corner"];
	drawsquarre();
	break;
     case 5: 
	[window setTitle: "5-D 1 cell per dimension"];
	drawcubbe();
	drawgryd();
	break;
     default: [window setTitle: "LCAU3T Plane Evolution"];break;}
	}

/*   PSsetgray(NX_BLACK); */
/*   PSselectfont("Times-Roman",16.0); */

}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LCAUView is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==6||drawview==7) 
		{[self setDrawOrigin:0 :0]; return self;}
	else
		[self setDrawOrigin: -floor(width/2) : -floor(height/2)]; 
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LCAUView.  The LCAUView changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events.  As it receives mouse-dragged events, the LCAUView updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LCAUView, the LCAUView 
 * registers the point and then sends a message to its delegate notifying it 
 * of the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect;

         double  x, y, ex, wy, eks, wye;
	 int k;

	[crossCursor set];
   	[self getBounds:&plotRect];

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];
 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				k=nearest(ex,wy);

//       if (theEvent->data.mouse.click==3) {} else 
//       if (theEvent->data.mouse.click==2) {snod=k;} else 
	{
	[self lockFocus];
//         PSsetinstance(YES);
	do {
// 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
//                ex=aPoint.x;
//                wy=aPoint.y;
				PSsetgray(NX_BLACK);
//				PSmoveto(ex+12.0,wy);
//				PSarc(ex, wy, 12.0, 0.0, 360.0);
//				PSstroke();
//				cntr[k][0]=ex;
//				cntr[k][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {
	/* on mouse-up, register point, inform delegate, and clean up state */
			looping = NO;
		}	
   	} while (looping && (theEvent = 
		[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


	}
	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

@end

/* end LCAUView.m */
