   
#import "RulePanel.h"
#import "nxlcau32.h"
#import <string.h>
#import <math.h>
#import <time.h>
#import "rec.h"

extern char arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern birular binrule;
extern int  co, dn;			/* connectivity, dimension */
extern char ascrule[KK][KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK][KK];
 char gf3rule[13];			/* coefficients of GF3 rule	*/
extern char ttrule[TS];
extern char tarule[TS];
extern char strule[KK+1][SS-1];

void    asctobin();
void	asczero();
void	auxzero();
void    chrucopy(char ii[KK][KK][KK][KK][KK],
		 char jj[KK][KK][KK][KK][KK],
		 int c);
void    clumin(char *c);
int     cyy(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();
int     isstot();
void    oxtoasc(char *r);
int     permut(int k, int n);
void    ptedbrul(birular *pr, birular *br, int k);
void    putionj(int i, int j);
int     ran2of3(int a, int b);
int     ran3of3(int a, int b, int c);
void    ranblin(double p0, double p1, double p2);
void    ranvachrul(char *c);
void    rule32();
void	sttoasc();
void    stzero();
void	totoasc();
int     totonu(int i);
void    ttzero();
int    ycc(int i);

/*extern int wolnum(char c);*/

void 	defineWrule(long int WW);
void    wrru(char *c, char ru[KK][KK][KK][KK][KK]);
void    wru(char *c);
void	xtoasc(int n);

extern int rec_c(char *z, Inst rprg, int l, struct fptbl dtbl[]);


void bincopy(birular *rz, int rx[KK][KK][KK][KK][KK]);
void binprint(birular rz);
void binprod(birular *rz, birular rx, birular ry);
void binsum(birular *rz, birular rx, birular ry);
void bintoasc();

int permu[RSYM/2][KK] = {
	{0, 1, 2},
	{0, 2, 1},
	{1, 0, 2},
	{1, 2, 0},
	{2, 0, 1},
	{2, 1, 0}
	};

char    xr[DS] = "0011001100110011";
char    xp[DS] = "1333333333333332";
char    xq[DS] = "2122112211221121";

int aritmetic=0;

extern struct 	fptbl dtbl[];
extern Inst 	xprg[][XLEN];
extern char	idef[][30];

int vecperm(int ii[KK], int n);
int allperm(
	    char wn[][WNML],
	    char ii[][KK][KK][KK][KK][KK],
	    char ru[KK][KK][KK][KK][KK]
	    );

int  longwolftoasc(char *c);
void numtobin2h(long int ru[KK][KK],long int  n);


@implementation RulePanel


/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  ch=[[sender selectedCell] title];
printf("loadSpecialRule: title = %s\n",ch);
  if (strcmp(ch,"appIcon")==0)     [self loadLowerPanel: [NXApp appIcon]];
  if (strcmp(ch,"arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
//   if (strcmp(ch,"composite")==0)   [self loadLowerPanel: compRuleBox];
  if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
//   if (strcmp(ch,"product")==0)     [self loadLowerPanel: prodRuleBox];
  if (strcmp(ch,"miscellaneous")==0)      [self loadLowerPanel: miscRuleBox];
  if (strcmp(ch,"permuted")==0)    [self loadLowerPanel: pmutRuleBox];
  if (strcmp(ch,"subset")==0)      [self loadLowerPanel: subsetRuleBox];
//   if (strcmp(ch,"reversible")==0)  [self loadLowerPanel: fredknRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox {
NXRect bxRect, loRect;
id cv;
  cv=[thisRuleBox contentView];
printf("thisRuleBox title = %d\n",[[cv subviews] count]);
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: cv];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=toRuleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- setDimension:sender {dn = [sender selectedRow]+1; return self;}

- protectGenRule:sender
{int i, j, k, i0, i1, i2, i3, i4;
  i=j=[sender selectedCol];
  i4=i%KK; i/=KK;
  i3=i%KK; i/=KK;
  i2=i%KK; i/=KK;
  i1=i%KK; i/=KK;
  i0=i%KK; i/=KK;
  k=auxrule[i0][i1][i2][i3][i4];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1][i2][i3][i4]=!k;
return self;
}

- relatedRule:sender {
char    ii[RSYM][KK][KK][KK][KK][KK], wnum[RSYM][WNML], c[WNML], *titl;
int	j, k, l, jj[KK];
  l=allperm(wnum,ii,ascrule);
  titl=[[sender selectedCell] title];
       if (strcmp(titl,"reflected")==0) k=6;
  else if (strcmp(titl,"transpose")==0) k=3;
  else if (strcmp(titl,"cycle")==0)     k=1;
  else if (strcmp(titl,"cluster")==0)   k=RSYM;
  else if (strcmp(titl,"least")==0)     k=l;
  else    				k=0;
  if (k==RSYM) {
    clumin(c);
printf("clumin should be %s\n",c);
    longwolftoasc(c);
    [self setAllRules: self];
    return self;
    }
  chrucopy(ascrule,ii[k],'w');
  [self setAllRules: self];
  if ([changeLine state]) {
    l=vecperm(jj,k);
    for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
    if (l) {
      for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
      for (j=0; j<AL; j++) arr1[j]=arr2[j];
      }
    }
return self;
}

/*  generate a table of permutations of a given rule         */
/*  and report the index of the rule with smallest wru       */
/*  wn - array to be filled with WNML-letter wolfram numbers */
/*  ii - array to be filled with ascrule symmetry images     */
/*  ru - reference KK8KK8KK table - e.g. ascrule	     */
/*  return value is the index of the least of all these	     */
/*  that is, wn[...] is the number, ii[...] is the rule      */
int allperm(wn,ii,ru) 
  char wn[RSYM][WNML], ii[][KK][KK][KK][KK][KK], ru[KK][KK][KK][KK][KK]; {
int k, l;
  chrucopy(ii[ 0],ru,     'w'); /* identity */
  chrucopy(ii[ 1],ru,     'y'); /* (012)    */
  chrucopy(ii[ 2],ii[1],  'y'); /* (021)    */  
  chrucopy(ii[ 3],ii[0],  't'); /* (12)     */
  chrucopy(ii[ 4],ii[1],  't'); /* (20)     */
  chrucopy(ii[ 5],ii[2],  't'); /* (01)     */  
  chrucopy(ii[ 6],ii[0],  'r'); /* reflect  */
  chrucopy(ii[ 7],ii[1],  'r'); /* (012)r   */
  chrucopy(ii[ 8],ii[2],  'r'); /* (021)r   */
  chrucopy(ii[ 9],ii[3],  'r'); /* (12)r    */
  chrucopy(ii[10],ii[4],  'r'); /* (20)r    */
  chrucopy(ii[11],ii[5],  'r'); /* (01)r    */
  for (k=0, l=0; k<RSYM; k++) {
    wrru(wn[k],ii[k]);
    if (strlen(wn[k]) > strlen(wn[l])) continue;
    if (strlen(wn[k]) < strlen(wn[l])) {l=k; continue;}
    if (strcmp(wn[k],wn[l]) < 0) l=k;
    }
  return l;
}

/* fill a KK-vector ii with inverse permutation #n of its indices  */
/* inverse is because this will be used to generate configurations */
/* return TRUE if there was a reflection of the neighborhood       */
int vecperm(ii,n) int ii[KK], n; {int i, k, l;
  l=!(n<6); k=(l?n-6:n);
  switch (k) {
    case 0: for (i=0; i<KK; i++)  ii[i] = i; break;
    case 1: for (i=0; i<KK; i++)  ii[i] = ycc(i); break;
    case 2: for (i=0; i<KK; i++)  ii[i] = cyy(i); break;
    case 3: for (i=0; i<KK; i++)  ii[i] = fli(i); break;
    case 4: for (i=0; i<KK; i++)  ii[i] = fli(ycc(i)); break;
    case 5: for (i=0; i<KK; i++)  ii[i] = fli(cyy(i)); break;
    default: for (i=0; i<KK; i++) ii[i] = i; break;}
  return l;
}

void wru(c) char *c; {wrru(c,ascrule);}

/* calculate wru from an argument rule  */
void wrru(c,ru) char *c, ru[KK][KK][KK][KK][KK]; {
int  i, j;
int  i0, i1, i2, i3;
j=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  i= 9*(ru[i0][i1][i2][i3][2]-'0')
    +3*(ru[i0][i1][i2][i3][1]-'0')
    +  (ru[i0][i1][i2][i3][0]-'0')
    +'0';
  if (i>'9') i=i+('A'-':');
  c[WNML-j-2]=i;
  j++;
  }
c[WNML-1]=0;
}

/* copy a related (character) rule */
/* c = w - no change		   */
/* c = y - cyclic permutation	   */
/* c = r - reflected		   */
/* c = t - transpose 1&2	   */

void chrucopy(ii,jj,c) 
char ii[KK][KK][KK][KK][KK], jj[KK][KK][KK][KK][KK], c; {
int i0, i1, i2, i3, i4;
  switch (c) {
    case 'w':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
      for (i4=0; i4<KK; i4++) 
        ii[i0][i1][i2][i3][i4]=jj[i0][i1][i2][i3][i4];
      break;
    case 'y':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
      for (i4=0; i4<KK; i4++) 
        ii[i0][i1][i2][i3][i4]=
		ycc(jj[cyy(i0)][cyy(i1)][cyy(i2)][cyy(i3)][cyy(i4)]);
      break;
    case 'r':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
      for (i4=0; i4<KK; i4++) 
        ii[i0][i1][i2][i3][i4]=jj[i4][i3][i2][i1][i0];
      break;
    case 't':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
      for (i4=0; i4<KK; i4++) 
        ii[i0][i1][i2][i3][i4]=
		fli(jj[fli(i0)][fli(i1)][fli(i2)][fli(i3)][fli(i4)]);
      break;
    default: break;}
}

int fli(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '2'; 
	case '2': return '1';
	case  0:  return 0;
	case  1:  return 2; 
	case  2:  return 1;
	default:  return '0';}
}

int cyy(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '0';
	case  0:  return 1;
	case  1:  return 2; 
	case  2:  return 0;
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '2';
	case '1': return '0'; 
	case '2': return '1';
	case  0:  return 2;
	case  1:  return 0; 
	case  2:  return 1;
	default:  return '0';}
}

void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK][KK][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<RSYM/2; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c) < 0) strcpy(c,d);
      }
    }
}

/* create the rule defined by the "symmetric rule" panel */
- symRule:sender {return self;}

- readWRule:sender {char *c;
   c=[sender stringValue];
   if (longwolftoasc(c)) [self setAllRules: self];
   else
     [ruleNumber setStringValue:"Invalid"]; 
 return self;
}

int longwolftoasc(char *c) {
char d[WNML], e;
int  i, l, n, i0, i1, i2, i3;
  l=strlen(c);
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'q') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'Q') n=e-'A'+10;
    else    return FALSE;
    d[WNML-1-l+i]=n;
    }
  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)  
  for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) {
    n=d[KK*KK*KK*KK-i0*KK*KK*KK-i1*KK*KK-i2*KK-i3-1];
    ascrule[i0][i1][i2][i3][0]='0'+n%KK; n/=KK;
    ascrule[i0][i1][i2][i3][1]='0'+n%KK; n/=KK;
    ascrule[i0][i1][i2][i3][2]='0'+n%KK;
    }
  return TRUE;
}

- setRule:sender 
{char ch[30]; int i, ii, j, jj, i0, i1, i2, i3, i4;
   wrru(ch,ascrule);
   [ruleNumber setStringValue: ch];
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];
  i4=j%KK; j/=KK;
  i3=j%KK; j/=KK;
  i2=j%KK; j/=KK;
  i1=j%KK; j/=KK;
  i0=j%KK; j/=KK;
  ascrule[i0][i1][i2][i3][i4]='0'+ii;
  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  return self;
}

- setAllRules:sender {char ch[WNML];
  wru(ch);
  [ruleNumber setStringValue: ch];
  asctobin();
   if      (istot()) {asctotot(); [self setTotRules: self];}
//    else if (isstot()) [totlRef setStringValue: "semitotalistic"];
      else {
	[toascru setEmptySelectionEnabled: YES];
	[toascru selectCellAt: -1: 0];
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
   [self showProbability: pSliders];
return self;
}

- freeAllRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<32; j++) 
      [[[ascru cellAt: i: j] setEnabled: YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender {
  granrule();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* generate a random rule */
void granrule() {int i, i0, i1, i2, i3, i4;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
         for (i3=0; i3<KK; i3++)
           for (i4=0; i4<KK; i4++) {
             i=(random()&0xFF)%KK;
	     ascrule[i0][i1][i2][i3][i4]=i+'0';
	     }
}

/* generate a random protected rule */
void granprule() {int i0, i1, i2, i3, i4, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
	 for (i3=0; i3<KK; i3++)
	   for (i4=0; i4<KK; i4++) {
              if (i%8 == 0) j=random();  i++;
  	      if (auxrule[i0][i1][i2][i3][i4]==0) 
		 ascrule[i0][i1][i2][i3][i4]='0'+j%KK;
	      j/=KK;
  }
}

- showProbability:sender 
{int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- randomLine:sender
{double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1],p[2]);
return self;
}

- sCellLine:sender {
  zerline();
  switch (dn) {
    case 1: putionj(1,0); break;
    case 2: ranplacor(); break;
    case 3: ransolcor(); break;
    case 5: ranplacor(); break;
    case 6: ransolcor(); break;
    default: putionj(1,0); break;}
return self;
}

- uniformLine:sender {ranblin(0.333,0.333,0.333); return self;}

- useRECLine:sender {
  [RECPanel makeKeyAndOrderFront: sender];
  [RECValue setStringValue: "*"];
return self;
}

- runRECLine:sender {
printf("hello from runRec\n");
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) 
	[RECValue setStringValue: "T"]; else [RECValue setStringValue: "F"];
return self;
}

/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- setDemo:sender {char ch[30];
   wrru(ch,ascrule);
   [ruleNumber setStringValue: ch];
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E    - - - - - - - - - - */

- pmutRule: sender {
int i0, i1, i2, i3, i4;
int p[KK], ru[KK][KK][KK][KK][KK];
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    ru[i0][i1][i2][i3][i4] = ascrule[p[i0]][p[i1]][p[i2]][p[i3]][p[i4]]-'0';
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    ascrule[i0][i1][i2][i3][i4] = p[ru[i0][i1][i2][i3][i4]]+'0';
  asctobin();
  [self setAllRules:self];
return self;
}

- pmutValue: sender {
int i0, i1, i2, i3, i4;
int p[KK], k;
  p[0]=[pMut0 selectedCol];
  p[1]=[pMut1 selectedCol];
  p[2]=[pMut2 selectedCol];
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    ascrule[i0][i1][i2][i3][i4] = p[ascrule[i0][i1][i2][i3][i4] - '0'] + '0';
  asctobin();
  [self setAllRules:self];
return self;
}

void ptedbrul(pr,br,k) birular *pr, *br; int k; 
  {int i; for (i=0; i<KK*KK*KK*KK*KK; i++) pr->one[i]=permu[k][br->one[i]];}

/* - - - - - - - - - - - - -   G F ( 3 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf3rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf3rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
    s=[sender selectedRow];
    gf3rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF3Rule:sender
{
//   int i; for (i=0; i<13; i++) printf("%1d ",gf3rule[i]); printf("\n");
//    gftoasc();
//    [self setAllRules:self];
//    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - -    S E M I T O T A L I S T I C   R U L E    - - - - - - - */
 
/*- setSemiState:sender {
  int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    strule[t%KK][t/KK]=s+'0';
    [toWindow setDocEdited:YES];
    sttoasc(); 
  return self;
  }
*/

- setSemiState:sender {
  int s, t,i;
    s=[sender selectedRow];
    t=[sender tag];
    if ([sender tag]==0) {
      for (i=0; i<KK; i++)
	{
           [[sem0 cellAt: i: [sender selectedCol]] setIntValue: NO];
           }
	 [[sem0 cellAt: s: [sender selectedCol]] setIntValue: YES];
    }
    if ([sender tag]==1) {
      for (i=0; i<KK; i++)
	{
           [[sem1 cellAt: i: [sender selectedCol]] setIntValue: NO];
           }
           [[sem1 cellAt: s: [sender selectedCol]] setIntValue: YES];
       } 
    if ([sender tag]==2) {
      for (i=0; i<KK; i++)
	{
           [[sem2 cellAt: i: [sender selectedCol]] setIntValue: NO];
           }
	   [[sem2 cellAt: s: [sender selectedCol]] setIntValue: YES];

    }


    strule[t][[sender selectedCol]]=s+'0';
    [toWindow setDocEdited:YES];
    //sttoasc(); 
  return self;
  }

- enterSemiRule:sender {
    sttoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [stWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- setTotalisticState:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    ttrule[t]=s+'0';
    [toWindow setDocEdited: YES];
  return self;
  }
 
- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [toWindow setDocEdited: NO];
return self;
}

- readTRule:sender {int i, j;
  i=[sender intValue];
  for (j=0; j<TS; j++) {ttrule[j]=i%KK+'0'; i/=KK;}
  totoasc();
  [self setAllRules: self];
return self;
}

- setTotRule:sender {
  ttrule[[sender selectedCol]]=[sender selectedRow]+'0';
  [self setTotRules: self];
  return self;
}

- setTotRules:sender {char ch[WNML]; int i, j;
  wrru(ch,ascrule);
  [ruleNumber setStringValue: ch];
  totoasc();
  asctobin();
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
  wrru(ch,ascrule);
  [ruleNumber setStringValue: ch];
//  [self nxasfreq];
   if (istot()) {
	[totlRef setStringValue: "totalistic"];
	[toRuleNumber setIntValue: totonu(0)];
	}
//    else if (isstot()) [totlRef setStringValue: "semitotalistic"];
      else {
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllTotRules:sender {
int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroTotRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranTRule:sender {int i;
  for (i=0; i<TS; i++) ttrule[i]=(random()&0xFF)%KK+'0';
  totoasc();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPTotRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* generate a random protected rule */
void granptotrule() {int i0, i1, i2, i3, i4, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
	 for (i3=0; i3<KK; i3++)
	    for (i4=0; i4<KK; i4++) {
              if (i%8 == 0) j=random();  i++;
  	      if (auxrule[i0][i1][i2][i3][i4]==0) 
		ascrule[i0][i1][i2][i3][i4]='0'+j%KK;
  j/=KK;
  }
}

/* - - - - - - - -    M I S C E L L A N E O U S   R U L E S    - - - - - - - */

- enterMiscRule:sender {
char c[WNML];
int  i, j, k, l;
int  i0, i1, i2, i3, i4;
int  s[KK];
  switch ([sender selectedRow]) {
    case 0: 					/* matching pair */
	for (i0=0; i0<KK; i0++)
	for (i1=0; i1<KK; i1++)
	for (i2=0; i2<KK; i2++)
	for (i3=0; i3<KK; i3++)
	for (i4=0; i4<KK; i4++) {
	  for (j=0; j<KK; j++) s[j]=0;
	  s[i0]++; s[i1]++; s[i2]++; s[i3]++; s[i4]++;
	  for (j=0, k=KK; j<KK; j++)
	         if (s[j]==4 || s[j]==3) {i=j; break;}
	    else if (s[j]==2 && k==KK) i=j;
	    else if (s[j]==2) {k=j; break;}
	  if (k!=KK) i=KK-i-k;
	  ascrule[i0][i1][i2][i3][i4]=i+'0';
	  }
	break;
    case 1: 					/* edible pair	 */
	for (i0=0; i0<KK; i0++)
	for (i1=0; i1<KK; i1++)
	for (i2=0; i2<KK; i2++)
	for (i3=0; i3<KK; i3++)
	for (i4=0; i4<KK; i4++) {
	       if (i0==i1) {i=i0; j=i2; k=i3;}
	  else if (i0==i2) {i=i0; j=i1; k=i3;}
	  else if (i0==i3) {i=i0; j=i1; k=i2;}
	  else if (i1==i2) {i=i1; j=i0; k=i3;}
	  else if (i1==i3) {i=i1; j=i0; k=i2;}
	  else    	   {i=i2; j=10; k=i1;}
	  l=(i+1)%KK;
	  if (l==j || l==k) i=l;
	  ascrule[i0][i1][i2][i3][i4]=i+'0';
	  }
	break;
    case 2: 					/* majority      */
	for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)
	for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) 
	for (i4=0; i4<KK; i4++) {
	  for (i=0; i<KK; i++) s[i]=0;
	  s[i0]++; s[i1]++; s[i2]++; s[i3]++; s[i4]++;
	  for (i=j=k=0; i<KK; i++) if (s[i]>j) {j=s[i]; k=i;}
	  if (j>RR/2) ascrule[i0][i1][i2][i3][i4]=k+'0';
	  }
	break;
    default: break;}
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];
   asctobin();
return self;
}

// 
// - eaterRule:sender
// {int ii, i0, i1, i2, i3, i4;
// for (i0=0; i0<KK; i0++)
// for (i1=0; i1<KK; i1++)
// for (i2=0; i2<KK; i2++)
// for (i3=0; i3<KK; i3++)
// for (i4=0; i4<KK; i4++) {
//   ii=(i2+1)%KK;
//   ascrule[i0][i1][i2][i3][i4]=i2+'0';
//   switch ([eatingCell selectedRow]) {
//     case 0: /* any neighbor eats */
//       if (ii==i0) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i1) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i3) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i4) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       break;
//     case 1: /* outers or inners in concert eat */
//       if (ii==i0&&ii==i4) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i1&&ii==i3) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//      if (ii==i0) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//      if (ii==i4) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       break;
//     case 2:  /* lefts or rights in concert eat */
//       if (ii==i0&&ii==i1) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i3&&ii==i4) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//      if (ii==i0) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//      if (ii==i4) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       break;
//     case 3: /* leftish or rightish in concert eat */
//       if (ii==i0&&ii==i3) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i1&&ii==i4) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//      if (ii==i0) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//      if (ii==i4) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       break;
//     case 4: /* either second neighbor eats */
//       if (ii==i0) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i4) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       break;
//     case 5: /* only leftish neighbors eat */
//       if (ii==i0) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i3) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       break;
//     case 6: /* any neighbor eats but nearest grab when equal */
//       if (ii==i0) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i1) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i3) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (ii==i4) ascrule[i0][i1][i2][i3][i4]=ii+'0';
//       if (i1==i2) ascrule[i0][i1][i2][i3][i4]=i1+'0';
//       break;
//     default: break;}
//   }
// return self;
// }

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophilic:sender {
//  oxtoasc(xr);
  ranvachrul(xp);
  [self setAllRules: self];
return self;
}

- xenophobic:sender {
//  oxtoasc(xr);
  ranvachrul(xq);
  [self setAllRules: self];
return self;
}

int ran2of3(a,b) int a, b; {
if ((random()%1001)<500) return a; else return b;
}

int ran3of3(a,b,c) int a, b, c; {
if ((random()%1001)<333) return a;
if ((random()%1001)<667) return b;
return c;
}

/* generate a random variable choice rule switch (c[KK*(KK*i0+i1)+i2]-'0') {*/
void ranvachrul(c) char *c; {int i0, i1, i2, i3, i4, i, j;
i=j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
     for (i2=0; i2<KK; i2++) 
        for (i3=0; i3<KK; i3++)
          for (i4=0; i4<KK; i4++) {
           switch (c[j]-'0') {
            	case 0: break;
    		case 1: i=0; break;
    		case 2: i=1; break;
    		case 3: i=ran2of3(0,1); break;
    	        default: i=0; break;}
	  j++; 	
    	  ascrule[i0][i1][i2][i3][i4]='0'+i;
  }
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender {int k, n, i0, i1, i2;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
return self;
}

- copyToDesign:sender {
return self;
}

- enterDesign:sender {
return self;
}

/* - - - - - - - - - - - -  T R I V I A   P A N E L  - - - - - - - - - - - - */

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq 
{return self;}

/*****   Ok 			15-08-95 	      *******/

/*     - - - - - - - - -  ARITHMETIC COMBINATION  - - - -  - - - */
 - arithmCombs:sender {
int i0, i1, i2, i3, i4;
birular aza, bzb, czc;
   [self readWRule: [twoRules cellAt: 0: 0]];
   asctobin();
   bincopy(&aza,&binrule);
   binprint(aza);
   [self readWRule: [twoRules cellAt: 1: 0]];
   asctobin();
   bincopy(&bzb,&binrule);
   binprint(bzb);
   switch ([sender selectedRow]) {
      case 0: binsum(&czc,aza,bzb); break;
      case 1: binprod(&czc,aza,bzb); break;
      default: printf("arithCombs\n"); 
   break;}
   binprint(czc);
   for (i0=0; i0<KK ;i0++) 
      for (i1=0; i1<KK ;i1++) 
	 for (i2=0; i2<KK ;i2++) 
	    for (i3=0; i3<KK; i3++)
	      for (i4=0; i4<KK; i4++)
               binrule.five[i0][i1][i2][i3][i4]=czc.five[i0][i1][i2][i3][i4]; 
   bintoasc();
   [self setAllRules: self];
return self;
}

- initTwoRules:sender {
char ch[30];
   granrule();
   wrru(ch,ascrule);
   [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: ch];
return self;
}

/* copy one binary rule from another */
void bincopy(rz,rx) birular *rz; int rx[KK][KK][KK][KK][KK];
{int i0, i1, i2, i3, i4;
   for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
         for (i2=0; i2<KK; i2++)
            for (i3=0; i3<KK; i3++)
              for (i4=0; i4<KK; i4++)
                 rz->five[i0][i1][i2][i3][i4]=rx[i0][i1][i2][i3][i4]+'0';
}


/*fill ascrule from binrule*/
void bintoasc()
{int i0, i1, i2, i3, i4;
   for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
         for (i2=0; i2<KK; i2++)
            for (i3=0; i3<KK; i3++)
              for (i4=0; i4<KK; i4++)
  ascrule[i0][i1][i2][i3][i4]=binrule.five[i0][i1][i2][i3][i4]+'0';
}

/*sum two binary rules mod KK*/
void binsum(rz,rx,ry) birular *rz, rx, ry;
{int i; for (i=0; i<K4; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*multiply two binary rules mod KK*/
void binprod(rz,rx,ry) birular *rz, rx, ry;
{int i; for (i=0; i<K4; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*print a binary rules (all 16 numbers)*/
void binprint(rz) birular rz;
{int i;
      for (i=0; i<KK*KK*KK*KK; i++) printf("%c",rz.one[i]+'0');
      printf("\n");
}

/* ================   c o m p o s i t e   r u l e    ============= */

  - composRule:sender
  { long int ru1, ru2, ru3, br1[KK][KK], br2[KK][KK], br3[KK][KK];
//    int  i0, i1, i2, i3;
//     ru1=[[composRuleNumb cellAt: 0: 0] intValue];
//     ru2=[[composRuleNumb cellAt: 1: 0] intValue];
//     ru3=[[composRuleNumb cellAt: 2: 0] intValue];
//     numtobin2h(br1, ru1);
//     numtobin2h(br2, ru2);
//     numtobin2h(br3, ru3);
//     for(i0=0; i0<KK; i0++) 
//      for(i1=0; i1<KK; i1++) 
//       for(i2=0; i2<KK; i2++)
//        for(i3=0; i3<KK; i3++)
//          ascrule[i0][i1][i2][i3] = //br3[br2[br1[i0][i1]][br1[i1][i2]]][br2[br1[i1][i2]][br1[i2][i3]]] + '0';
//     [self setAllRules: self];
     return self;
    }

   - compxRule:sender
   {long int i;
      i= [[composRuleNumb cellAt: 0: 0] intValue];
      [[composRuleNumb cellAt: 0: 0] setIntValue :
                       [[composRuleNumb cellAt: 1: 0] intValue]];
      [[composRuleNumb cellAt: 1: 0] setIntValue :
                       [[composRuleNumb cellAt: 2: 0] intValue]];

     [[composRuleNumb cellAt: 2: 0] setIntValue: i];
     return self;
     }

   - comprRule:sender 
    {
       [[composRuleNumb cellAt: 0: 0] setIntValue: random()% 16];
       [[composRuleNumb cellAt: 1: 0] setIntValue: random()% 16];
       [[composRuleNumb cellAt: 2: 0] setIntValue: random()% 16];
      return self;

      }

   void numtobin2h(ru, n) long int ru[KK][KK], n;
  { int i, j, i0, i1;
    i=n;
      for(i0=0; i0<KK; i0++) for(i1=0; i1<KK; i1++) {
        j=i%KK; i/=KK;
        ru[i0][i1] = j;
        }
    }

@end

/* end RulePanel.m */
