
/* 
 * SQARView.h -- Interface file for the SQARView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface SQARView:View {

	id		keyWindow;
	id		bernView;
	id		freqView;
	id		freqWindow;
	id		planeView;
	id		planeWindow;
	id		SqarView;
	id		SqarWindow;
	id		rtrnView;
	id		rtrnWindow;
	id		sqarView;
	id		sqarWindow;

	id		theZMatrix;
	id		theOMatrix;
	id		theTMatrix;
	id		mMent;
	id		reStore;
	id		genEv;
	id		moSaic;
	id		moTies;
	id		probGrid;
	id		probDots;

	id		rulePanel;
	id		ruleNumber;
	id		ruleType;
	id		pSliders;
	id		pWindows;
	id		tRuleNumber;

	id		menuCopy;
	id		menuPrint;

	id		tiTime;
	id		tiDat;

	id		delegate;
	id		crossCursor;

}

- checkerBoard:sender;
- drawBern:sender;
- drawEmpBern:sender;
- drawFreq:sender;
- drawMosaic:sender;
- drawPlEvol:sender;
- drawRtrn:sender;
- drawSmEvol:sender;
- drawSmMosaic:sender;
- drawTraj:sender;
- enterRule:sender;
- loadSqar:sender;
- printFreq:sender;
- printMosaic:sender;
- printPlEvol:sender;
- printRtrn:sender;
- printRule:sender;
- printSlowFreq:sender;
- printSmEvol:sender;
- printSmMosaic:sender;
- printTraj:sender;
- randomLine:sender;
- readWRule:sender;
- readTRule:sender;
- resetRule:sender;
- sCellLine:sender;
- showProbability:sender;
- slowFreq:sender;
- uniformLine:sender;

- uprule:sender;
- lerule:sender;
- dorule:sender;
- rirule:sender;
- idrule:sender;
- mjrule:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end SQARView.h */
