
/* ardn3t.c						*/
/* program for lcau3t option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/

/*  Copyright (C) 1990	*/
/*  Harold V. McIntosh	*/

# include <math.h>
# include <lcau3t.h>

extern int  binrule[KK][KK][KK][KK];

# define LUR		 1	/* left panel upper left row */
# define LUC		 0	/* left panel upper left col */
# define LLR		17	/* left panel lower right row */
# define LLC		15	/* left panel lower right col */
# define RUR		 1	/* right panel upper left row */
# define RUC		16	/* right panel upper left col */
# define RLR		21	/* right panel lower right row */
# define RLC		39	/* right panel lower right col */

# define CUR		 1	/* cycle panel upper left row */
# define CUC		 0	/* cycle panel upper left col */
# define CLR		24	/* cycle panel lower right row */
# define CLC		39	/* cycle panel lower right col */

# define EROW		23	/* row for sample evolution */

# define K2	KK*KK
# define K3	KK*K2
# define K4	K2*K2
# define K5	K2*K3
# define K6	K3*K3
# define K8	K4*K4
# define AV	KK*KK*KK
# define HH	60		/* points in histogram */

/* edit the Garden of Eden and ancestor screen */
edard() {
char c;
int    amat[KK][KK][KK][KK][KK][KK];
int    bmat[KK][KK][KK][KK][KK][KK];
int    fmat[KK][KK][KK][KK][KK][KK];
int    gmat[KK][KK][KK][KK][KK][KK];
int    hmat[KK][KK][KK][KK][KK][KK];
int    xmat[KK][KK][KK][KK][KK][KK];
int    tmat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    umat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    vmat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    i, l, ll, m;
int    i0;
int    s0, s1;
int    t0, t1;
double bb, e, f, ff, g, gg;
double ii, ss, h, hh, kay;
double go, gr, gl;
double rr[3][2], k[4][2];
double stt, st0[K4/2+1], st1[K4/2+1], st2[K4/2+1];
unsigned int a, b, s, t;
unsigned int tsum(), ttsum(), ttvsum();
unsigned int nzel(), nnzel();

videomode(COLGRAF);
videopalette(YELREGR);
videocursor(0,0,0);
scrrul();
woruno(0,22);
videoscroll(1,0,24,39,0,0);
asctobin();
zmat(amat);  djmat(amat,0);
zmat(bmat);  djmat(bmat,1);
zzmat(tmat); tensq(tmat,amat,bmat);
unmat(umat);
zmat(gmat);
zmat(xmat);
stt=0.0;
l=m=ss=ll=0;
kay=(double)KK;
s0=nzel(amat);
t0=tsum(amat);
s1=nzel(bmat);
t1=tsum(bmat);
clard();
videocursor(0,20,0); printf("a=%3u, b=%3u",t0,t1);
  while (0<1) {
  videocursor(0,0,36);  videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,38);  videoputc(c,2);
  videocursor(0,0,36);  videoputc(' ',2);
  videocursor(0,0,0);
  switch (c) {

    case 'a':
	l=1;
	cymat(gmat,amat);
	pmat(gmat,10,5);
	videocursor(0,20,0); printf("%4u (%2u) %5u",t0,s0,1);
	break;
    case 'b':
	l=1;
	cymat(gmat,bmat);
	pmat(gmat,10,5);
	videocursor(0,20,0); printf("%4u (%2u) %5u",t1,s1,1);
	break;
    case 'x':
	l=m;
	cymat(gmat,xmat);
	pmat(gmat,10,5);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,0); printf("%4u (%2u) %5u",t,s,1);
	break;
    case 'h': histo(amat,bmat); break;
    case 'j': rvers(amat,bmat); break;
    case 'l':
	mmat(hmat,gmat,gmat);
	mmat(fmat,hmat,hmat);
	mmat(hmat,fmat,fmat);
	mmat(fmat,gmat,hmat);
	a=tsum(hmat);
	b=tsum(fmat);
	pmat(gmat,10,5);
        bb=0.0; if (a!=0) bb=((double)(b))/((double)(a));
	videocursor(0,4,20); printf("%3u %3u",a,b);
	videocursor(0,6,20); printf("  %6.3f",bb);
	break;
    case 'q':
	l*=2;
	mmat(hmat,gmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,10,5);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'r': rever(); break;
    case 's':
	videoscroll(1,0,24,39,0,0);
	videocursor(0,1,0);
	if (ss==0) {printf("S required first"); break;}
	  for (i0=0; i0<K4/2+1; i0++)
	    {f=st0[i0]; if (f>0.0) {
	    g=st1[i0]/f;
	    h=st2[i0]/f;
	    e=sqrt(h-g*g);
            printf("%1u %6.1f, %6.3f, %6.2f, %6.3f\n",i0,f,g,h,e);
	    }}
	f=st0[K4/2]-stt; if (f>0.0) {
	    g=(st1[K4/2]-2.0*stt)/f;
	    h=(st2[K4/2]-4.0*stt)/f;
	    e=sqrt(h-g*g);
	    printf("\n");
	    printf("- %6.1f, %6.3f, %6.2f, %6.3f\n",f,g,h,e);
	    }
	printf("t %6.1f, %6.3f, %6.2f, %6.3f\n",stt,2.0,4.0,0.0);
	break;
    case 't':
	ll=1;
	ppmat(tmat,100,200);
	ccymat(umat,tmat);
	t=ttsum(tmat);
	s=nnzel(tmat);
	f=(double)t;
	g=f/kay;
	h=kay;
	videocursor(0,20,36); printf("%2u",ll);
	videocursor(0,22,25); printf("t=%3u, s=%3u ",t,s);
	f=(double)t;
	break;
    case 'A':
	l++;
	mmat(hmat,amat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,10,5);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'B':
	l++;
	mmat(hmat,bmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,10,5);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'Q':
	ll*=2;
	mmmat(vmat,umat,umat);
	ccymat(umat,vmat);
	ppmat(umat,100,200);
	t=ttsum(umat);
	s=nnzel(umat);
	f=(double)t;
	h=h*h;
	g=f/h;
	videocursor(0,20,36); printf("%2u",ll);
	videocursor(0,22,18); printf("%6u [%4u]        ",t,s);
	videocursor(0,23,20); printf("                   ");
	videocursor(0,24,20); printf("                   ");
	break;
    case 'S':
	for (i0=0; i0<K4/2+1; i0++)
  	  {st0[i0]=st1[i0]=st2[i0]=0.0;}
	stt=0.0;
	allmo(&stt,st0,st1,st2);
	ss=1;
	break;
    case 'T':
	ll++;
	mmmat(vmat,tmat,umat);
	ccymat(umat,vmat);
	ppmat(umat,100,200);
	t=ttsum(umat);
	s=nnzel(umat);
	ff=f; f=(double)t;
	h=h*kay;
	gg=g; g=f/h;
	videocursor(0,20,36); printf("%2u",ll);
	videocursor(0,22,18); printf("%6u [%4u]%6.3f  ",t,s,f/ff);
	videocursor(0,23,20); printf("m[2] ratio:%6.3f ",sqrt(f/ff));
	gr=g/gg; gl=log(gr); go=g*exp(-((double)(ll-1))*gl);
	videocursor(0,24,20); printf("%5.3f exp(%6.3fn)",sqrt(go),0.5*gl);
	for (i=0, ii=0.0; i<8; i++, ii+=1.0)
	  {
	  hh=go*exp(ii*gl)-64.0;
	  if (hh<0.0) hh=-hh;
	  videocursor(0,2+i,20); printf("%2u %5.3f",i,sqrt(hh));
	  }
	for (i=8, ii=8.0; i<16; i++, ii+=1.0)
	  {
	  hh=go*exp(ii*gl)-64.0;
	  if (hh<0.0) hh=-hh;
	  videocursor(0,2+i-8,30); printf("%2u %5.3f",i,sqrt(hh));
	  }
	break;
    case 'X':
	l+=m;
	mmat(hmat,xmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,10,5);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case '=': m=l; cymat(xmat,gmat); break;
    case '/': videoscroll(1,0,24,39,0,0); break;
    case '.':
	videoscroll(1,0,24,39,0,0);
	pmat(amat,1,0);
	pmat(bmat,1,10);
	videocursor(0,22,2); printf("a=%1u",t0);
	videocursor(0,22,8); printf("b=%1u",t1);
	pmat(gmat,10,5);
	break;
    case '?': clard(); break;

    default: break;
    } /* end switch */
  }   /* end while  */
  videopalette(WHCYMAG);
  videomode(T80X25);
}

/* calculate the first two moments of all rules */
allmo(stt,st0,st1,st2)
  double *stt, st0[K4/2+1], st1[K4/2+1], st2[K4/2+1]; {
int tmat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int umat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int vmat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int amat[KK][KK][KK][KK][KK][KK], bmat[KK][KK][KK][KK][KK][KK];
int xvec[KK][KK][KK][KK][KK][KK], yvec[KK][KK][KK][KK][KK][KK];
int ig, ih, hg[301];
int i, j;
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15;
int t0, t1;
double f, g, ff;
  i=0;
  videoscroll(1,0,24,39,0,0);
  for (i0=0;  i0<301; i0++)   hg[i0]=0;
  for (i0=10; i0<360; i0+=50) videodot( 99,i0,1);
  for (i0=10; i0<360; i0+=50) videodot(199,i0,1);
  for (i0=0; i0<KK; i0++) {if (kbdst()) break; binrule[0][0][0][0]=i0;
  for (i1=0; i1<KK; i1++) {if (kbdst()) break; binrule[0][0][0][1]=i1;
  for (i2=0; i2<KK; i2++) {if (kbdst()) break; binrule[0][0][1][0]=i2;
  for (i3=0; i3<KK; i3++) {if (kbdst()) break; binrule[0][0][1][1]=i3;
  for (i4=0; i4<KK; i4++) {if (kbdst()) break; binrule[0][1][0][0]=i4;
  for (i5=0; i5<KK; i5++) {if (kbdst()) break; binrule[0][1][0][1]=i5;
  for (i6=0; i6<KK; i6++) {if (kbdst()) break; binrule[0][1][1][0]=i6;
  for (i7=0; i7<KK; i7++) {if (kbdst()) break; binrule[0][1][1][1]=i7;
  for (i8=0; i8<KK; i8++) {if (kbdst()) break; binrule[1][0][0][0]=i8;
  for (i9=0; i9<KK; i9++) {if (kbdst()) break; binrule[1][0][0][1]=i9;
  for (i10=0; i10<KK; i10++) {if (kbdst()) break; binrule[1][0][1][0]=i10;
  for (i11=0; i11<KK; i11++) {if (kbdst()) break; binrule[1][0][1][1]=i11;
  for (i12=0; i12<KK; i12++) {if (kbdst()) break; binrule[1][1][0][0]=i12;
  for (i13=0; i13<KK; i13++) {if (kbdst()) break; binrule[1][1][0][1]=i13;
  for (i14=0; i14<KK; i14++) {if (kbdst()) break; binrule[1][1][1][0]=i14;
  for (i15=0; i15<KK; i15++) {if (kbdst()) break; binrule[1][1][1][1]=i15;
    zmat(amat);  djmat(amat,0);
    zmat(bmat);  djmat(bmat,1);
    zzmat(tmat); tensq(tmat,amat,bmat);
    t0=tsum(bmat);
    t1=tsum(amat);
    if (t0<=t1)
      {
/*      mmmat(vmat,tmat,tmat);  */
/*      mmmat(umat,tmat,vmat);  */
/*      mmmat(vmat,tmat,umat);  */
/*      ff=(double)ttsum(umat); */
/*      f= (double)ttsum(vmat); */
      uuvec(xvec);
      mmvec(yvec,tmat,xvec);
      mmvec(xvec,tmat,yvec);
      mmvec(yvec,tmat,xvec);
      mmvec(xvec,tmat,yvec);
      ff=(double)ttvsum(yvec);
      f =(double)ttvsum(xvec);
      g=f/ff;
      ig=(int)(300.0*((g-2.0)/(4.0-2.0)));
      hg[ig]++;
      ih=hg[ig]; if (ih>100) ih=100+ih/10;
      videodot(199-ih,10+ig,2);
      st0[t0]+=1.0; st1[t0]+=g; st2[t0]+=g*g;
      if (g==2.0) *stt+=1.0;
      videocursor(0,10,20); printf("%5u %6.3f",i,g);
      }
    i++;
    }}}}}}}}}}}}}}}}
  if (kbdst()) kbdin();
}

/* calculate tensor square axa+bxb */
tensq(tmat,amat,bmat)
  int tmat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
  int amat[KK][KK][KK][KK][KK][KK];
  int bmat[KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (i10=0; i10<KK; i10++)
for (i11=0; i11<KK; i11++)
  {
  tmat[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][i10][i11]+=
	amat[i0][i2][i4][i6][i8][i10]*amat[i1][i3][i5][i7][i9][i11]+
	bmat[i0][i2][i4][i6][i8][i10]*bmat[i1][i3][i5][i7][i9][i11];
  }
}

/* coefficients of characteristic equation */
cheq(k,z) double k[4][2]; int z[KK][KK]; {
int t, p, d;
t=z[0][0]+z[1][1]+z[2][2];
p=z[0][0]*z[1][1]-z[0][1]*z[1][0];
p+=z[1][1]*z[2][2]-z[1][2]*z[2][1];
p+=z[2][2]*z[0][0]-z[2][0]*z[0][2];
d=z[0][0]*(z[1][1]*z[2][2]-z[1][2]*z[2][1]);
d+=z[0][1]*(z[1][2]*z[2][0]-z[1][0]*z[2][2]);
d+=z[0][2]*(z[2][1]*z[1][0]-z[1][1]*z[2][0]);
k[0][0]= 1.0;       k[0][1]=0.0;
k[1][0]=-(double)t; k[1][1]=0.0;
k[2][0]= (double)p; k[2][1]=0.0;
k[3][0]=-(double)d; k[3][1]=0.0;
}

clard() {
  videomode(COLGRAF);
  videopalette(YELREGR);
  videocursor(0,0,0);
  scrrul();
  woruno(0,22);
  videocursor(0,3,0);
  printf("counterimages\n\n");
  printf("ab  - 0,1 matrix\n");
  printf("AB  - times abc \n");
  printf("=Xx - saved mtrx\n");
  printf("Tt  - tensor sq \n");
  printf("Qq  - square    \n");
  printf("Ll  - eigenvalue\n");
  printf("h   - histogram \n");
  printf("j   - ancestors \n");
  printf("Ss  - all rules \n");
  printf("                \n");
  printf("?/   - hlp clr  \n");
  printf("<cr> - exit\n\n");
}

rvers(amat,bmat) 
int amat[KK][KK][KK][KK][KK][KK],
    bmat[KK][KK][KK][KK][KK][KK]; {
int    xmat[KK][KK][KK][KK][KK][KK];
int    m1[KK][KK][KK][KK][KK][KK][KK];
int    m2[KK][KK][KK][KK][KK][KK][KK][KK];
int    m3[KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    i0, i1, i2, i3, i4, i5;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
int    t5[KK][KK][KK][KK][KK], t6[KK][KK][KK][KK][KK][KK];
double s, t, u, kk1, kk2, kk3, kk4, kk5, kk6;

kk1=(double)KK;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
kk5=(double)K5;
kk6=(double)K6;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],amat);
cymat(&m1[1],bmat);
t1[0]=tsum(&m1[0]);
t1[1]=tsum(&m1[1]);
videocursor(0,2,0); printf("%3u,%3u",t1[0],t1[1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);
  t2[i0][i1]=tsum(&m2[i0][i1]);
  }
videocursor(0,4,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3u,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2],&m1[i0],&m2[i1][i2]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2]);
  }
videocursor(0,6,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  printf("%3u,",t3[i0][i1][i2]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(xmat,&m2[i0][i1],&m2[i2][i3]);
  t4[i0][i1][i2][i3]=tsum(xmat);
  }
videocursor(0,8,0);
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3u,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {
  mmat(xmat,&m2[i0][i1],&m3[i2][i3][i4]);
  t5[i0][i1][i2][i3][i4]=tsum(xmat);
  }
videocursor(0,11,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    printf("%3u,",t5[i0][i1][i2][i3][i4]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  mmat(xmat,&m3[i0][i1][i2],&m3[i3][i4][i5]);
  t6[i0][i1][i2][i3][i4][i5]=tsum(xmat);
  }
videocursor(0,16,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
    printf("%3u,",t6[i0][i1][i2][i3][i4][i5]);
  printf("\n");
  }

for (i0=0,s=0.0; i0<KK; i0++) {t=((double)(t1[i0]-AV)); s+=t*t;}
t=sqrt(s/kk1);
videocursor(0,2,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {t=((double)(t2[i0][i1]-AV)); s+=t*t;}
t=sqrt(s/kk2);
videocursor(0,4,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); s+=t*t;}
t=sqrt(s/kk3);
videocursor(0,6,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); s+=t*t;}
t=sqrt(s/kk4);
videocursor(0,9,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {t=((double)(t5[i0][i1][i2][i3][i4]-AV)); s+=t*t;}
t=u=sqrt(s/kk5);
videocursor(0,14,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {t=((double)(t6[i0][i1][i2][i3][i4][i5]-AV)); s+=t*t;}
t=sqrt(s/kk6);
videocursor(0,23,33); printf("%6.2f",t);

s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("ratio: %6.2f",s);

}

histo(amat,bmat) 
int amat[KK][KK][KK][KK][KK][KK],
    bmat[KK][KK][KK][KK][KK][KK]; {
int    xmat[KK][KK][KK][KK][KK][KK];
int    m1[KK][KK][KK][KK][KK][KK][KK];
int    m2[KK][KK][KK][KK][KK][KK][KK][KK];
int    m4[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[HH];
double s, t, kk8;

kk8=(double)K8;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0],amat);
cymat(&m1[1],bmat);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1],&m1[i0],&m1[i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3],&m2[i0][i1],&m2[i2][i3]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(xmat,&m4[i0][i1][i2][i3],&m4[i4][i5][i6][i7]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(xmat);
  }

for (i0=0; i0<HH; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {i=t8[i0][i1][i2][i3][i4][i5][i6][i7]; if (i<HH) h8[i]++;}

po=da=0;
for (i=0; i<HH; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h8[i];
  da+=i*h8[i];
  videocursor(0,i0+1,13*i1+1);
  printf("%2u %4u %4u",i,h8[i],po);
  }

videocursor(0,22,0);  printf("total: %4u in %3u pts;",AV*K8,K8);
videocursor(0,22,24); printf("average: %2u",AV);
videocursor(0,23,0);  printf("beyond: %3u in %3u pts,",AV*K8-da,K8-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
videocursor(0,23,24); printf("sigma:  %6.2f",t);
s=1.0; if (t>=1.0) s=exp(log(t)/8.0);
videocursor(0,24,0); printf("relative sigma: %6.2f",s);
}

/* search for the reversed rule */
rever() {
int revrule[KK][KK][KK][KK];
int i0, i1, i2, i3;
  videocursor(0,17,0); printf(".");
  if (runiq(binrule,revrule)) {
    videocursor(0,17,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      printf("%1d",revrule[i0][i1][i2][i3]);
    printf("\n");
    }
  videocursor(0,18,0); printf(".");
  if (suniq(binrule)) {
    videocursor(0,18,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      printf("%1d",binrule[i0][i1][i2][i3]);
    printf("\n");
    }
  videocursor(0,19,0); printf(".");
  if (tuniq(binrule)) {
    videocursor(0,19,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      printf("%1d",binrule[i0][i1][i2][i3]);
    printf("\n");
    }
}

int runiq(brul,rrul) 
int brul[KK][KK][KK][KK], rrul[KK][KK][KK][KK]; {
int a, b, d, e;
int j0, j1, j2, j3, j4, j5, j6;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
  rrul[j0][j1][j2][j3]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
  {
  a=brul[j0][j1][j2][j3];
  b=brul[j1][j2][j3][j4];
  d=brul[j2][j3][j4][j5];
  e=brul[j3][j4][j5][j6];
  if (rrul[a][b][d][e]==KK) rrul[a][b][d][e]=j3;
  if (rrul[a][b][d][e]!=j3) return(0);
  }
return(1);
}

int suniq(brul) int brul[KK][KK][KK][KK]; {
int a, b, e, f, g, h, c[KK][KK][KK][KK][KK][KK];
int j0, j1, j2, j3, j4, j5, j6, j7, j8;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
  c[j0][j1][j2][j3][j4][j5]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
for (j8=0; j8<KK; j8++)
  {
  a=brul[j0][j1][j2][j3];
  b=brul[j1][j2][j3][j4];
  e=brul[j2][j3][j4][j5];
  f=brul[j3][j4][j5][j6];
  g=brul[j4][j5][j6][j7];
  h=brul[j5][j6][j7][j8];
  if (c[a][b][e][f][g][h]==KK) c[a][b][e][f][g][h]=j4;
  if (c[a][b][e][f][g][h]!=j4) return(0);
  }
return(1);
}

int tuniq(brul) int brul[KK][KK][KK][KK]; {
int a, b, e, f, g, h, i, j, c[KK][KK][KK][KK][KK][KK][KK][KK];
int j0, j1, j2, j3, j4, j5, j6, j7, j8, j9, j10;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
  c[j0][j1][j2][j3][j4][j5][j6][j7]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
for (j8=0; j8<KK; j8++)
for (j9=0; j9<KK; j9++)
for (j10=0; j10<KK; j10++)
  {
  a=brul[j0][j1][j2][j3];
  b=brul[j1][j2][j3][j4];
  e=brul[j2][j3][j4][j5];
  f=brul[j3][j4][j5][j6];
  g=brul[j4][j5][j6][j7];
  h=brul[j5][j6][j7][j8];
  i=brul[j6][j7][j8][j9];
  j=brul[j7][j8][j9][j10];
  if (c[a][b][e][f][g][h][i][j]==KK) c[a][b][e][f][g][h][i][j]=j5;
  if (c[a][b][e][f][g][h][i][j]!=j5) return(0);
  }
return(1);
}

/* print matrix */
pmat(z,i,j) int i, j, z[KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5;
videocursor(0,1,0);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    {
    videocursor(0,i+(i0*KK+i1)*KK+i2,j);
    for (i3=0; i3<KK; i3++)
    for (i4=0; i4<KK; i4++)
    for (i5=0; i5<KK; i5++)
      printf("%1d",z[i0][i1][i2][i3][i4][i5]);
    }
}

/* display K6xK6 matrix */
ppmat(z,i,j) int i, j, z[K6][K6]; {
int i0, i1;
for (i0=0; i0<K6; i0++)
for (i1=0; i1<K6; i1++)
  videodot(i+i0,j+i1,(z[i0][i1]==0)?0:1);
}

/* total matrix elements */
unsigned int tsum(z) int z[K6]; {int t, i;
for (i=t=0; i<K6; i++) t+=z[i]; return t;}

/* total matrix elements */
unsigned int ttsum(z) int z[K6*K6]; {int t, i;
for (i=t=0; i<K6*K6; i++) t+=z[i]; return t;}

/* total vector elements */
unsigned int ttvsum(z) int z[K6]; {int t, i;
for (i=t=0; i<K6; i++) t+=z[i]; return t;}

/* count nonzero matrix elements */
unsigned int nzel(z) int z[K6]; {int t, i;
for (i=t=0; i<K6; i++) if (z[i]!=0) t++; return t;}

/* count nonzero matrix elements */
unsigned int nnzel(z) int z[K6*K6]; {int t, i;
for (i=t=0; i<K6*K6; i++) if (z[i]!=0) t++; return t;}

/* copy one K3xK3 matrix from another: z=x */
cymat(z,x) int  z[K6], x[K6]; {int i;
for (i=0; i<K6; i++) z[i]=x[i];}

/* copy one K6xK6 matrix from another: z=x */
ccymat(z,x)
 int  z[K6*K6], x[K6*K6]; {int i;
  for (i=0; i<K6*K6; i++) z[i]=x[i];}

/* multiply K3xK3 matrices */
mmat(z,x,y) int z[K3][K3], x[K3][K3], y[K3][K3];
{
int i0, i1, i2;
  for (i0=0; i0<K3; i0++)
  for (i2=0; i2<K3; i2++)
      {
      z[i0][i2]=0;
      for (i1=0; i1<K3; i1++) z[i0][i2]+=x[i0][i1]*y[i1][i2];
      }
}

/* multiply K6xK6 matrices */
mmmat(z,x,y) int z[K6][K6], x[K6][K6], y[K6][K6];
{
int i0, i1, i2;
  for (i0=0; i0<K6; i0++)
  for (i2=0; i2<K6; i2++)
      {
      z[i0][i2]=0;
      for (i1=0; i1<K6; i1++) z[i0][i2]+=x[i0][i1]*y[i1][i2];
      }
}

/* multiply aK6xK6 matrix by K6x1 vector */
mmvec(z,x,y) int z[K6], x[K6][K6], y[K6]; {int i0, i1;
for (i0=0; i0<K6; i0++)
  {z[i0]=0; for (i1=0; i1<K6; i1++) z[i0]+=x[i0][i1]*y[i1];}
}

/* generate the de Bruijn fragment evolving to l in matrix z */
djmat(z,l) int l, z[KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    z[i0][i1][i2][i1][i2][i3]=(binrule[i0][i1][i2][i3]==l)?1:0;
}

/* generate a K6xK6 unit matrix */
unmat(z) int z[K6][K6]; {int i; zzmat(z); for (i=0; i<K6; i++) z[i][i]=1;}

/* generate a K6x1 uniform vector */
uuvec(z) int z[K6]; {int i; for (i=0; i<K6; i++) z[i]=1;}

/* zero a K3xK3 matrix */
zmat(z) int  z[K3*K3]; {int i; for (i=0; i<K3*K3; i++) z[i]=0;}

/* zero a K6xK6 matrix */
zzmat(z) int  z[K6*K6]; {int i; for (i=0; i<K6*K6; i++) z[i]=0;}

/* end */
