
/* nxardn22.c						*/
/* program for lcau22 option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/

/*  Copyright (C) 1987	*/
/*  Copyright (C) 1988	*/
/*  Copyright (C) 1989	*/
/*  Copyright (C) 1990	*/
/*  Harold V. McIntosh	*/

# include <math.h>
# include "nxlcau22.h"

extern char  binrule[KK][KK][KK][KK][KK];

# define LUR		 1	/* left panel upper left row */
# define LUC		 0	/* left panel upper left col */
# define LLR		17	/* left panel lower right row */
# define LLC		15	/* left panel lower right col */
# define RUR		 1	/* right panel upper left row */
# define RUC		16	/* right panel upper left col */
# define RLR		21	/* right panel lower right row */
# define RLC		39	/* right panel lower right col */

# define CUR		 1	/* cycle panel upper left row */
# define CUC		 0	/* cycle panel upper left col */
# define CLR		24	/* cycle panel lower right row */
# define CLC		39	/* cycle panel lower right col */

# define EROW		23	/* row for sample evolution */

# define K2	KK*KK
# define K3	KK*K2
# define K4	K2*K2
# define K5	K2*K3
# define K6	K3*K3
# define K8	K4*K4
# define AV	KK*KK*KK*KK


extern int    amat[KK][KK][KK][KK][KK][KK][KK][KK];
extern int    bmat[KK][KK][KK][KK][KK][KK][KK][KK];
extern int    fmat[KK][KK][KK][KK][KK][KK][KK][KK];
extern int    gmat[KK][KK][KK][KK][KK][KK][KK][KK];
extern int    hmat[KK][KK][KK][KK][KK][KK][KK][KK];
extern int    xmat[KK][KK][KK][KK][KK][KK][KK][KK];
extern int    tmat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
extern int    umat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
extern int    vmat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];

double stt, sta[5][K5+1];

/* edit the counterimage and Garden of Eden panel */
edard() {
char c;
int    amat[KK][KK][KK][KK][KK][KK][KK][KK];
int    bmat[KK][KK][KK][KK][KK][KK][KK][KK];
int    fmat[KK][KK][KK][KK][KK][KK][KK][KK];
int    gmat[KK][KK][KK][KK][KK][KK][KK][KK];
int    hmat[KK][KK][KK][KK][KK][KK][KK][KK];
int    xmat[KK][KK][KK][KK][KK][KK][KK][KK];
int    a, b;
int    l, m, s, t, s0, s1, t0, t1;
double bb;

videomode(COLGRAF);
videopalette(YELREGR);
videocursor(0,0,0);
scrrul();
videoscroll(1,0,24,39,0,0);
asctobin();
zmat(amat); dmat(amat,0);
zmat(bmat); dmat(bmat,1);
zmat(gmat);
zmat(xmat);
m=0;
s0=nzel(amat);
t0=tsum(amat);
s1=nzel(bmat);
t1=tsum(bmat);
videocursor(0,20,0);
printf("a=%3u, b=%3u",t0,t1);
  while (0<1) {
  videocursor(0,0,36);  videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,38);  videoputc(c,2);
  videocursor(0,0,36);  videoputc(' ',2);
  videoscroll(1,0,16,15,0,0);
  videocursor(0,0,0);
  switch (c) {

    case 'a':
	l=1;
	cmat(gmat,amat);
	pmat(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t0,s0,1);
	break;
    case 'b':
	l=1;
	cmat(gmat,bmat);
	pmat(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t1,s1,1);
	break;
    case 'x':
	l=m;
	cmat(gmat,xmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,1);
	break;
    case 'h': histo(amat,bmat); break;
    case 'l':
	mmat(hmat,gmat,gmat);
	mmat(fmat,hmat,hmat);
	mmat(hmat,fmat,fmat);
	mmat(fmat,gmat,hmat);
	a=tsum(hmat);
	b=tsum(fmat);
	pmat(gmat);
        bb=0.0; if (a!=0) bb=((double)(b))/((double)(a));
	videocursor(0,4,20);
	printf("%3u %3u",a,b);
	videocursor(0,6,20);
	printf("  %6.3f",bb);
	break;
    case 'r': rever(); break;
    case 'A':
	l++;
	mmat(hmat,amat,gmat);
	cmat(gmat,hmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,l);
	break;
    case 'B':
	l++;
	mmat(hmat,bmat,gmat);
	cmat(gmat,hmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,l);
	break;
    case 'Q':
	l*=2;
	mmat(hmat,gmat,gmat);
	cmat(gmat,hmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,l);
	break;
    case 'X':
	l+=m;
	mmat(hmat,xmat,gmat);
	cmat(gmat,hmat);
	pmat(gmat);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,16);
	printf("%3u (%3u) %5u",t,s,l);
	break;
    case '=': m=l; cmat(xmat,gmat); break;
    case '.': rvers(amat,bmat); break;
    case '/': videoscroll(1,0,24,39,0,0); break;
    case '?': clard(); break;

    default: break;
    } /* end switch */
  }   /* end while  */
  videopalette(WHCYMAG);
  videomode(T80X25);
}

/* clear edard screen and set up menu */
clard() {
  videomode(COLGRAF);
  videopalette(YELREGR);
  videocursor(0,0,0);
  scrrul();
  videocursor(0,3,0);
  printf("counterimages\n\n");
  printf("ab - 0,1 matrix\n");
  printf("AB - times a,b \n");
  printf("xX - saved mtrx\n");
  printf("= - save matrix\n");
  printf("Q - square    \n");
  printf("l - eigenvalue\n");
  printf("h - histogram \n");
  printf(". - ancestors \n");
  printf("               \n");
  printf("               \n");
  printf("?/   - clr scrn\n");
  printf("<cr> - exit\n\n");
}

rvers(amat,bmat) 
int amat[KK][KK][KK][KK][KK][KK][KK][KK],
    bmat[KK][KK][KK][KK][KK][KK][KK][KK]; {
int    xmat[KK][KK][KK][KK][KK][KK][KK][KK];
int    m1[KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    m2[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    m3[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    i0, i1, i2, i3, i4, i5;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
int    t5[KK][KK][KK][KK][KK], t6[KK][KK][KK][KK][KK][KK];
double s, t, u, kk1, kk2, kk3, kk4, kk5, kk6;

kk1=(double)KK;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
kk5=(double)K5;
kk6=(double)K6;
videoscroll(1,0,24,39,0,0);
cmat(&m1[0][0][0][0][0][0][0][0][0],amat);
cmat(&m1[1][0][0][0][0][0][0][0][0],bmat);
t1[0]=tsum(&m1[0][0][0][0][0][0][0][0][0]);
t1[1]=tsum(&m1[1][0][0][0][0][0][0][0][0]);
videocursor(0,2,0); printf("%3u,%3u",t1[0],t1[1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1][0][0][0][0][0][0][0][0],
	&m1[i0][0][0][0][0][0][0][0][0],
	&m1[i1][0][0][0][0][0][0][0][0]);
  t2[i0][i1]=tsum(&m2[i0][i1][0][0][0][0][0][0][0][0]);
  }
videocursor(0,4,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3u,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2][0][0][0][0][0][0][0][0],
	&m1[i0][0][0][0][0][0][0][0][0],
	&m2[i1][i2][0][0][0][0][0][0][0][0]);
  t3[i0][i1][i2]=
	tsum(&m3[i0][i1][i2][0][0][0][0][0][0][0][0]);
  }
videocursor(0,6,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  printf("%3u,",t3[i0][i1][i2]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(xmat,
	&m2[i0][i1][0][0][0][0][0][0][0][0],
	&m2[i2][i3][0][0][0][0][0][0][0][0]);
  t4[i0][i1][i2][i3]=tsum(xmat);
  }
videocursor(0,8,0);
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3u,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {
  mmat(xmat,
	&m2[i0][i1][0][0][0][0][0][0][0][0],
	&m3[i2][i3][i4][0][0][0][0][0][0][0][0]);
  t5[i0][i1][i2][i3][i4]=tsum(xmat);
  }
videocursor(0,11,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    printf("%3u,",t5[i0][i1][i2][i3][i4]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  mmat(xmat,
	&m3[i0][i1][i2][0][0][0][0][0][0][0][0],
	&m3[i3][i4][i5][0][0][0][0][0][0][0][0]);
  t6[i0][i1][i2][i3][i4][i5]=tsum(xmat);
  }
videocursor(0,16,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
    printf("%3u,",t6[i0][i1][i2][i3][i4][i5]);
  printf("\n");
  }

for (i0=0,s=0.0; i0<KK; i0++) {t=((double)(t1[i0]-AV)); s+=t*t;}
t=sqrt(s/kk1);
videocursor(0,2,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {t=((double)(t2[i0][i1]-AV)); s+=t*t;}
t=sqrt(s/kk2);
videocursor(0,4,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); s+=t*t;}
t=sqrt(s/kk3);
videocursor(0,6,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); s+=t*t;}
t=sqrt(s/kk4);
videocursor(0,9,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
  {t=((double)(t5[i0][i1][i2][i3][i4]-AV)); s+=t*t;}
t=u=sqrt(s/kk5);
videocursor(0,14,33); printf("%6.2f",t);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {t=((double)(t6[i0][i1][i2][i3][i4][i5]-AV)); s+=t*t;}
t=sqrt(s/kk6);
videocursor(0,23,33); printf("%6.2f",t);

s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("ratio: %6.2f",s);

}

histo(amat,bmat) 
int amat[KK][KK][KK][KK][KK][KK][KK][KK],
    bmat[KK][KK][KK][KK][KK][KK][KK][KK]; {
int    xmat[KK][KK][KK][KK][KK][KK][KK][KK];
int    m1[KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    m2[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    m4[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[AV*K8+1];
double s, t, kk8;

kk8=(double)K8;
videoscroll(1,0,24,39,0,0);
cmat(&m1[0][0][0][0][0][0][0][0][0],amat);
cmat(&m1[1][0][0][0][0][0][0][0][0],bmat);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1][0][0][0][0][0][0][0][0],
	&m1[i0][0][0][0][0][0][0][0][0],
	&m1[i1][0][0][0][0][0][0][0][0]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3][0][0][0][0][0][0][0][0],
	&m2[i0][i1][0][0][0][0][0][0][0][0],
	&m2[i2][i3][0][0][0][0][0][0][0][0]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(xmat,
	&m4[i0][i1][i2][i3][0][0][0][0][0][0][0][0],
	&m4[i4][i5][i6][i7][0][0][0][0][0][0][0][0]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(xmat);
  }

for (i0=0; i0<AV*K8+1; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  h8[t8[i0][i1][i2][i3][i4][i5][i6][i7]]++;

po=da=0;
for (i=0; i<60; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h8[i];
  da+=i*h8[i];
  videocursor(0,i0+1,13*i1+1);
  printf("%2u %4u %4u",i,h8[i],po);
  }

videocursor(0,22,0);  printf("total: %3u in %3u pts;",AV*K8,K8);
videocursor(0,23,0);  printf("average: %2u",AV);
videocursor(0,22,23); printf("beyond: %3u, %3u",AV*K8-da,K8-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
videocursor(0,23,24); printf("sigma:   %6.2f",t);

}

/* search for the reversed rule */
rever() {
int revrule[KK][KK][KK][KK][KK];
int i0,i1,i2,i3,i4;
  videocursor(0,17,0); printf(".");
  if (runiq(binrule,revrule)) {
    videocursor(0,17,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
    for (i4=0; i4<KK; i4++)
      printf("%1d",revrule[i0][i1][i2][i3][i4]);
    printf("\n");
    }
  videocursor(0,18,0); printf(".");
  if (suniq(binrule)) {
    videocursor(0,18,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
    for (i4=0; i4<KK; i4++)
      printf("%1d",binrule[i0][i1][i2][i3][i4]);
    printf("\n");
    }
  videocursor(0,19,0); printf(".");
  if (tuniq(binrule)) {
    videocursor(0,19,0);
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
    for (i4=0; i4<KK; i4++)
      printf("%1d",binrule[i0][i1][i2][i3][i4]);
    printf("\n");
    }
}

int runiq(brul,rrul) 
int brul[KK][KK][KK][KK][KK], rrul[KK][KK][KK][KK][KK]; {
int a, b, d, e, f;
int j0, j1, j2, j3, j4, j5, j6, j7, j8;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
  rrul[j0][j1][j2][j3][j4]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
for (j8=0; j8<KK; j8++)
  {
  a=brul[j0][j1][j2][j3][j4];
  b=brul[j1][j2][j3][j4][j5];
  d=brul[j2][j3][j4][j5][j6];
  e=brul[j3][j4][j5][j6][j7];
  f=brul[j4][j5][j6][j7][j8];
  if (rrul[a][b][d][e][f]==KK) rrul[a][b][d][e][f]=j4;
  if (rrul[a][b][d][e][f]!=j4) return(0);
  }
return(1);
}

int suniq(brul) int brul[KK][KK][KK][KK][KK]; {
int a, b, e, f, g, h, i, c[KK][KK][KK][KK][KK][KK][KK];
int j0, j1, j2, j3, j4, j5, j6, j7, j8, j9, j10;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
  c[j0][j1][j2][j3][j4][j5][j6]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
for (j8=0; j8<KK; j8++)
for (j9=0; j9<KK; j9++)
for (j10=0; j10<KK; j10++)
  {
  a=brul[j0][j1][j2][j3][j4];
  b=brul[j1][j2][j3][j4][j5];
  e=brul[j2][j3][j4][j5][j6];
  f=brul[j3][j4][j5][j6][j7];
  g=brul[j4][j5][j6][j7][j8];
  h=brul[j5][j6][j7][j8][j9];
  i=brul[j6][j7][j8][j9][j10];
  if (c[a][b][e][f][g][h][i]==KK) c[a][b][e][f][g][h][i]=j5;
  if (c[a][b][e][f][g][h][i]!=j5) return(0);
  }
return(1);
}

int tuniq(brul) int brul[KK][KK][KK][KK][KK]; {
int a, b, e, f, g, h, i, j, k, c[KK][KK][KK][KK][KK][KK][KK][KK][KK];
int j0, j1, j2, j3, j4, j5, j6, j7, j8, j9, j10, j11, j12;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
for (j8=0; j8<KK; j8++)
  c[j0][j1][j2][j3][j4][j5][j6][j7][j8]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
for (j8=0; j8<KK; j8++)
for (j9=0; j9<KK; j9++)
for (j10=0; j10<KK; j10++)
for (j11=0; j11<KK; j11++)
for (j12=0; j12<KK; j12++)
  {
  a=brul[j0][j1][j2][j3][j4];
  b=brul[j1][j2][j3][j4][j5];
  e=brul[j2][j3][j4][j5][j6];
  f=brul[j3][j4][j5][j6][j7];
  g=brul[j4][j5][j6][j7][j8];
  h=brul[j5][j6][j7][j8][j9];
  i=brul[j6][j7][j8][j9][j10];
  j=brul[j7][j8][j9][j10][j11];
  k=brul[j8][j9][j10][j11][j12];
  if (c[a][b][e][f][g][h][i][j][k]==KK) c[a][b][e][f][g][h][i][j][k]=j6;
  if (c[a][b][e][f][g][h][i][j][k]!=j6) return(0);
  }
return(1);
}

/* calculate the first two moments of all rules */
void allmo(stt,sta)
  double *stt, sta[5][K3+1]; {
int tmat[KK][KK][KK][KK][KK][KK][KK][KK];
int umat[KK][KK][KK][KK][KK][KK][KK][KK];
int vmat[KK][KK][KK][KK][KK][KK][KK][KK];
int amat[KK][KK][KK][KK], bmat[KK][KK][KK][KK];
int ig, ih, hg[301];
int i, i0, i1, i2, i3, i4, i5, i6, i7;
int t0, t1;
double f, g, ff;
  i=0;
//  videoscroll(1,0,24,39,0,0);
  for (i0=0;  i0<301; i0++)   hg[i0]=0;
//  for (i0=10; i0<360; i0+=50) videodot( 99,i0,1);
//  for (i0=10; i0<360; i0+=50) videodot(199,i0,1);
  for (i0=0; i0<KK; i0++) {binrule[0][0][0][0][0]=i0;
  for (i1=0; i1<KK; i1++) {binrule[0][0][1][0][0]=i1;
  for (i2=0; i2<KK; i2++) {binrule[0][1][0][0][0]=i2;
  for (i3=0; i3<KK; i3++) {binrule[0][1][1][0][0]=i3;
  for (i4=0; i4<KK; i4++) {binrule[1][0][0][0][0]=i4;
  for (i5=0; i5<KK; i5++) {binrule[1][0][1][0][0]=i5;
  for (i6=0; i6<KK; i6++) {binrule[1][1][0][0][0]=i6;
  for (i7=0; i7<KK; i7++) {binrule[1][1][1][0][0]=i7;
    zmat(amat);  djmat(amat,0);
    zmat(bmat);  djmat(bmat,1);
    zzmat(tmat); tensq(tmat,amat,bmat);
    t0=tsum(amat);
    t1=tsum(bmat);
    if (t0<=t1)
      {
      mmmat(vmat,tmat,tmat);
      mmmat(umat,tmat,vmat);
      mmmat(vmat,tmat,umat);
      ff=(double)ttsum(umat);
      f= (double)ttsum(vmat);
      g=f/ff;
      ig=(int)(300.0*((g-2.0)/(4.0-2.0)));
      hg[ig]++;
      ih=hg[ig]; if (ih>100) ih=100+ih/10;
      videodot(ih,10+ig,2);
      sta[0][t0]+=1.0;
      sta[1][t0]+=g; sta[2][t0]+=g*g;
      if (sta[3][t0]>=g) sta[3][t0]=g;
      if (sta[4][t0]<=g) sta[4][t0]=g;
      if (g==2.0) *stt+=1.0;
      }
    i++;
    }}}}}}}}
}

/* print matrix */
pmat(z) int z[KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0,i1,i2,i3,i4,i5,i6,i7;
videocursor(0,1,0);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    {
    for (i4=0; i4<KK; i4++)
    for (i5=0; i5<KK; i5++)
    for (i6=0; i6<KK; i6++)
    for (i7=0; i7<KK; i7++)
      printf("%1d",z[i0][i1][i2][i3][i4][i5][i6][i7]);
    printf("\n");
    }
}

/* display 64x64 matrix */
void qqmat(z,i,j) int i, j, z[64][64]; {
int i0, i1, k, l;
for (i0=0; i0<64; i0++)
for (i1=0; i1<64; i1++)
  {
  k=0; l=z[i0][i1];
  if (l==1) k=1;
  if (l>=2) k=2;
  if (l>=4) k=3;
  videodot(i+i0,j+i1,k);
  }
}

/* total matrix elements */
int tsum(z) int z[KK][KK][KK][KK][KK][KK][KK][KK]; {
int t, i0,i1,i2,i3,i4,i5,i6,i7;
  t=0;
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      for (i4=0; i4<KK; i4++)
      for (i5=0; i5<KK; i5++)
      for (i6=0; i6<KK; i6++)
      for (i7=0; i7<KK; i7++)
        t+=z[i0][i1][i2][i3][i4][i5][i6][i7];
  return t;
}

/* total matrix elements */
unsigned int ttsum(z) int *z; {int t, i;
for (i=t=0; i<4096; i++) t+=z[i]; return t;}

/* count nonzero matrix elements */
int nzel(z) int z[KK][KK][KK][KK][KK][KK][KK][KK]; {
int t, i0,i1,i2,i3,i4,i5,i6,i7;
  t=0;
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      for (i4=0; i4<KK; i4++)
      for (i5=0; i5<KK; i5++)
      for (i6=0; i6<KK; i6++)
      for (i7=0; i7<KK; i7++)
        if (z[i0][i1][i2][i3][i4][i5][i6][i7]!=0) t++;
  return t;
}

/* copy one 16x16 matrix from another: z=x */
cmat(z,x)
 int  z[KK][KK][KK][KK][KK][KK][KK][KK];
 int  x[KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0,i1,i2,i3,i4,i5,i6,i7;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
  for (i6=0; i6<KK; i6++)
  for (i7=0; i7<KK; i7++)
    z[i0][i1][i2][i3][i4][i5][i6][i7]=x[i0][i1][i2][i3][i4][i5][i6][i7];
}

/* multiply matrices */
mmat(z,x,y) 
int z[KK][KK][KK][KK][KK][KK][KK][KK]; 
int x[KK][KK][KK][KK][KK][KK][KK][KK]; 
int y[KK][KK][KK][KK][KK][KK][KK][KK]; 
{
int i0,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11;
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      {
      for (i8=0; i8<KK; i8++)
      for (i9=0; i9<KK; i9++)
      for (i10=0; i10<KK; i10++)
      for (i11=0; i11<KK; i11++)
        {
        z[i0][i1][i2][i3][i8][i9][i10][i11]=0;
        for (i4=0; i4<KK; i4++)
        for (i5=0; i5<KK; i5++)
        for (i6=0; i6<KK; i6++)
        for (i7=0; i7<KK; i7++)
          z[i0][i1][i2][i3][i8][i9][i10][i11]+=
          x[i0][i1][i2][i3][i4][i5][i6][i7]*
          y[i4][i5][i6][i7][i8][i9][i10][i11];
        }
      }
}
/* generate the de Bruijn fragment evolving to l in matrix z */
dmat(z,l) int l, z[KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0,i1,i2,i3,i4;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    z[i0][i1][i2][i3][i1][i2][i3][i4]=
      (binrule[i0][i1][i2][i3][i4]==l)?1:0;
}

/* zero a 16x16 matrix */
zmat(z) int  z[KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0,i1,i2,i3,i4,i5,i6,i7;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
  for (i6=0; i6<KK; i6++)
  for (i7=0; i7<KK; i7++)
    z[i0][i1][i2][i3][i4][i5][i6][i7]=0;
}

/* zero a 64x64 matrix */
void zzmat(z) int  *z; {int i; for (i=0; i<4096; i++) z[i]=0;}

/* generate a 64x64 unit matrix */
void unmat(z) int z[64][64]; {int i; zzmat(z); for (i=0; i<64; i++) z[i][i]=1;}

/* copy one 64x64 matrix from another: z=x */
void cymat(z,x) int  z[4096], x[4096]; {int i;
for (i=0; i<4096; i++) z[i]=x[i];}

/* calculate row sums */
void rowsum(x,z) 
int x[KK][KK][KK][KK], 
z[KK][KK][KK][KK][KK][KK][KK][KK]; 
{int i0, i1, i2, i3, j0, j1, j2, j3;
for (i0=0; i0<KK; i0++) 
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++) {
  x[i0][i1][i2][i3]=0;
  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
    x[i0][i1][i2][i3]+=z[i0][i1][i2][i3][j0][j1][j2][j3];
  }
}

/* calculate column sums */
void colsum(x,z) 
int x[KK][KK][KK][KK], 
z[KK][KK][KK][KK][KK][KK][KK][KK]; 
{int i0, i1, i2, i3, j0, j1, j2, j3;
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++) {
  x[j0][j1][j2][j3]=0;
    for (j0=0; j0<KK; j0++)
    for (j1=0; j1<KK; j1++)
    for (j2=0; j2<KK; j2++)
    for (j3=0; j3<KK; j3++)
      x[i0][i1][i2][i3]+=z[i0][i1][i2][i3][j0][j1][j2][j3];
   }
}

/* copy one K4xK4 matrix from another: z=x */
void ccymat(z,x)
 int  z[4096], x[4096]; {int i;
  for (i=0; i<4096; i++) z[i]=x[i];}

/* multiply64x64 matrices */
void mmmat(z,x,y) int z[64][64], x[64][64], y[64][64];
{
int i0, i1, i2;
  for (i0=0; i0<64; i0++)
  for (i2=0; i2<64; i2++)
      {
      z[i0][i2]=0;
      for (i1=0; i1<64; i1++) z[i0][i2]+=x[i0][i1]*y[i1][i2];
      }
}

/* generate the de Bruijn fragment evolving to l in matrix z */
void djmat(z,l) int l, z[KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    z[i4][i3][i2][i1][i3][i2][i1][i0]=(binrule[i0][i1][i2][i3][i4]==l)?1:0;
}

/* calculate tensor square axa+bxb */
void tensq(tmat,amat,bmat)
  int tmat[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
  int amat[KK][KK][KK][KK][KK][KK][KK][KK];
  int bmat[KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5, i6, i7;
int j0, j1, j2, j3, j4, j5, j6, j7;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++)
for (j7=0; j7<KK; j7++)
  {
  tmat[i0][i1][i2][i3][i4][i5][i6][i7][j0][j1][j2][j3][j4][j5][j6][j7]+=
	amat[i0][i1][i4][i5][j0][j1][j4][j5]*amat[i2][i3][i6][i7][j2][j3][j6][j7]+
	bmat[i0][i1][i4][i5][j0][j1][j4][j5]*bmat[i2][i3][i6][i7][j2][j3][j6][j7];
  }
}

/* end nxardn22.c */
