
/* nxardn32.c						*/
/* program for lcau32 option 'e'			*/
/* Garden of Eden and counterimage calculations		*/
/* Harold V. McIntosh, 10 February 1990			*/

/*  Copyright (C) 1990	*/
/*  Harold V. McIntosh	*/

# include <math.h>
# include "nxlcau32.h"
# include "nxardn32.h"

extern int  binrule[KK][KK];

# define LUR		 1	/* left panel upper left row */
# define LUC		 0	/* left panel upper left col */
# define LLR		17	/* left panel lower right row */
# define LLC		15	/* left panel lower right col */
# define RUR		 1	/* right panel upper left row */
# define RUC		16	/* right panel upper left col */
# define RLR		21	/* right panel lower right row */
# define RLC		39	/* right panel lower right col */

# define CUR		 1	/* cycle panel upper left row */
# define CUC		 0	/* cycle panel upper left col */
# define CLR		24	/* cycle panel lower right row */
# define CLC		39	/* cycle panel lower right col */

# define EROW		23	/* row for sample evolution */

# define K1	KK

int  h8[HH];

/* edit the Garden of Eden and ancestor calculation */
void edard() {
char c;
int    amat[KK][KK];
int    bmat[KK][KK];
int    cmat[KK][KK];
int    fmat[KK][KK];
int    gmat[KK][KK];
int    hmat[KK][KK];
int    xmat[KK][KK];
int    tmat[KK][KK][KK][KK];
int    umat[KK][KK][KK][KK];
int    vmat[KK][KK][KK][KK];
int    i, l, ll, m;
int    i0, i1, i2;
int    s0, s1, s2;
int    t0, t1, t2;
double bb, e, f, ff, g, gg;
double ii, ss, h, hh, kay;
double ex, wy, go, gr, gl;
double cave, csig, xave, xsig; 
double cvec[KK][KK];
double xvec[KK][KK];
double rr[3][2], k[4][2];
double stt, sta[5][K2+1][K2+1];
unsigned int a, b, s, t;
unsigned int ttsum();

videomode(COLGRAF);
videopalette(YELREGR);
videocursor(0,0,0);
scrrul();
videoscroll(1,0,24,39,0,0);
asctobin();
zmat(amat);  djmat(amat,0);
zmat(bmat);  djmat(bmat,1);
zmat(cmat);  djmat(cmat,2);
zzmat(tmat); tensq(tmat,amat,bmat,cmat);
unmat(umat);
zmat(gmat);
zmat(xmat);
stt=0.0;
l=m=ss=ll=0;
kay=(double)KK;
s0=nzel(amat);
t0=tsum(amat);
s1=nzel(bmat);
t1=tsum(bmat);
s2=nzel(cmat);
t2=tsum(cmat);
clard();
woruno(0,28);
  while (0<1) {
  videocursor(0,0,36);  videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,38);  videoputc(c,2);
  videocursor(0,0,36);  videoputc(' ',2);
  woruno(0,28);
/*  pmat(amat,1,0);
/*  pmat(bmat,1,4);
/*  pmat(cmat,1,8);
/*  videocursor(0,5,0); printf("a=%1u",t0);
/*  videocursor(0,5,4); printf("b=%1u",t1);
/*  videocursor(0,5,8); printf("c=%1u",t2);
*/
  videocursor(0,0,0);
  switch (c) {

    case 'a':
	l=1;
	cymat(gmat,amat);
	pmat(gmat,7,4);
	videocursor(0,13,0); printf("%3u (%1u) %5u",t0,s0,1);
	break;
    case 'b':
	l=1;
	cymat(gmat,bmat);
	pmat(gmat,7,4);
	videocursor(0,13,0); printf("%3u (%1u) %5u",t1,s1,1);
	break;
    case 'c':
	l=1;
	cymat(gmat,cmat);
	pmat(gmat,7,4);
	videocursor(0,13,0); printf("%3u (%1u) %5u",t2,s2,1);
	break;
//    case 'h': histo(amat,bmat,cmat); break;
//    case 'j': rvers(amat,bmat,cmat); break;
    case 'l':
	mmat(hmat,gmat,gmat);
	mmat(fmat,hmat,hmat);
	mmat(hmat,fmat,fmat);
	mmat(fmat,gmat,hmat);
	a=tsum(hmat);
	b=tsum(fmat);
	pmat(gmat,7,4);
        bb=0.0; if (a!=0) bb=((double)(b))/((double)(a));
	videocursor(0,4,20); printf("%3u/ %3u",b,a);
	videocursor(0,6,20); printf("  %6.3f",bb);
	break;
    case 'p':
	l=0;
	mtmat(hmat,gmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,7,4);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,20,0); printf("%4u (%2u) %5u",t,s,l);
	break;
    case 'r': rever(); break;
    case 's':
	videoscroll(1,0,24,39,0,0);
	videocursor(0,1,0);
	if (ss==0) {printf("S required first"); break;}
	  for (i0=0; i0<K2+1; i0++)
	  for (i1=i0; i1<K2+1; i1++)
	    {f=sta[0][i0][i1]; if (f>0.0) {
	    g=sta[1][i0][i1]/f;
	    h=sta[2][i0][i1]/f;
	    e=sqrt(h-g*g);
            printf("%1u%1u %6.1f, %6.3f, %6.2f, %6.3f\n",i0,i1,f,g,h,e);
	    }}
	f=sta[0][3][3]-stt; if (f>0.0) {
	    g=(sta[1][3][3]-3.0*stt)/f;
	    h=(sta[2][3][3]-9.0*stt)/f;
	    e=sqrt(h-g*g);
	    printf("\n");
	    printf("-- %6.1f, %6.3f, %6.2f, %6.3f\n",f,g,h,e);
	    }
	printf("tt %6.1f, %6.3f, %6.2f, %6.3f\n",stt,3.0,9.0,0.0);
	break;
    case 't':
	ll=1;
	ppmat(tmat,12,0);
	ccymat(umat,tmat);
	t=ttsum(tmat);
	s=nnzel(tmat);
	f=(double)t;
	g=f/kay;
	h=kay;
	videocursor(0,22,25); printf("t=%3u, s=%3u ",t,s);
	f=(double)t;
	break;
    case 'u':			/* variance of eigenvector components	*/
	auua(&xave,&xsig,&ex,&wy,cvec,xvec,umat);
	videocursor(0,22,0); printf("av%6.3f, va%6.3f",xave,xsig);
	videocursor(0,24,0); printf(" +%6.3f, ..%6.3f",wy,ex);
	break;
    case 'v':			/* variance of column sums 		*/
	avva(&cave,&csig,cvec,tmat);
	videocursor(0,23,0); printf("av%6.3f, va%6.3f",cave,csig);
	break;
    case 'w':
      videoscroll(1,0,24,39,0,0);
      videocursor(0,1,0);
      if (ss==0) {printf("S required first"); break;}
        for (i0=0; i0<K2+1; i0++)
        for (i1=i0; i1<K2+1; i1++)
	  {f=sta[0][i0][i1]; if (f>0.0) {
	  e=sta[1][i0][i1]/f;
          g=sta[3][i0][i1];
          h=sta[4][i0][i1];
	  ff=((double)(i0*i0+i1*i1+(K2-i0-i1)*(K2-i0-i1)))/9.0;
          printf("%1u%1u  %6.3f, %6.3f, %6.3f, %6.3f\n",i0,i1,g,h,e,ff);
        }}
      break;
    case 'x':
	l=m;
	cymat(gmat,xmat);
	pmat(gmat,7,4);
	s=nzel(gmat);
	t=tsum(gmat);
	videocursor(0,13,0); printf("%3u (%1u) %5u",t,s,1);
	break;
    case 'A':
	l++;
	mmat(hmat,amat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,7,4);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,13,0); printf("%3u (%1u) %5u",t,s,l);
	break;
    case 'B':
	l++;
	mmat(hmat,bmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,7,4);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,13,0); printf("%3u (%1u) %5u",t,s,l);
	break;
    case 'C':
	l++;
	mmat(hmat,cmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,7,4);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,13,0); printf("%3u (%1u) %5u",t,s,l);
	break;
    case 'L':
	cheq(k,gmat);
	videocursor(0,22,0);
	printf("%4.1f,%4.1f,%4.1f,%4.1f",k[0][0],k[1][0],k[2][0],k[3][0]);
//	cubi(rr,k);
	videocursor(0,18,0); printf("%6.3f,%6.3f",rr[0][0],rr[0][1]);
	videocursor(0,19,0); printf("%6.3f,%6.3f",rr[1][0],rr[1][1]);
	videocursor(0,20,0); printf("%6.3f,%6.3f",rr[2][0],rr[2][1]);
	pmat(gmat,7,4);
	break;
    case 'P':
	ll=0;
	mmtmat(vmat,umat,umat);
	ccymat(umat,vmat);
	ppmat(umat,12,0);
	t=ttsum(umat);
	s=nnzel(umat);
	videocursor(0,20,36); printf("%2u",ll);
	videocursor(0,22,18); printf("%6u [%4u]        ",t,s);
	videocursor(0,23,20); printf("                   ");
	videocursor(0,24,20); printf("                   ");
	break;
    case 'Q':
	l*=2;
	mmat(hmat,gmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,7,4);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,13,0); printf("%3u (%1u) %5u",t,s,l);
	break;
    case 'S':
      for (i0=0; i0<5; i0++)
      for (i1=0; i1<K2+1; i1++) for (i2=0; i2<K2+1; i2++) sta[i0][i1][i2]=0.0;
      for (i1=0; i1<K2+1; i1++) for (i2=0; i2<K2+1; i2++) sta[3][i1][i2]=10.0;
      stt=0.0;
      allmo(&stt,sta);
      ss=1;
      break;
    case 'T':
	ll++;
	mmmat(vmat,tmat,umat);
	ccymat(umat,vmat);
	ppmat(umat,12,0);
	t=ttsum(umat);
	s=nnzel(umat);
	ff=f; f=(double)t;
	h=h*kay;
	gg=g; g=f/h;
	videocursor(0,22,20); printf("%5u [%2u] %6.3f  ",t,s,f/ff);
	videocursor(0,23,20); printf("m[2] ratio:%6.3f ",sqrt(f/ff));
	gr=g/gg; gl=log(gr); go=g*exp(-((double)(ll-1))*gl);
	videocursor(0,24,20); printf("%5.3f exp(%6.3fn)",sqrt(go),0.5*gl);
	for (i=0, ii=0.0; i<8; i++, ii+=1.0)
	  {
	  hh=go*exp(ii*gl)-9.0;
	  if (hh<0.0) hh=-hh;
	  videocursor(0,2+i,20); printf("%2u %5.3f",i,sqrt(hh));
	  }
	for (i=8, ii=8.0; i<16; i++, ii+=1.0)
	  {
	  hh=go*exp(ii*gl)-9.0;
	  if (hh<0.0) hh=-hh;
	  videocursor(0,2+i-8,30); printf("%2u %5.3f",i,sqrt(hh));
	  }
	break;
    case 'X':
	l+=m;
	mmat(hmat,xmat,gmat);
	cymat(gmat,hmat);
	pmat(gmat,7,4);
	t=tsum(gmat);
	s=nzel(gmat);
	videocursor(0,13,0); printf("%3u (%1u) %5u",t,s,l);
	break;
    case '=': m=l; cymat(xmat,gmat); break;
    case '.':
	videoscroll(1,0,24,39,0,0);
	pmat(amat,1,0);
	pmat(bmat,1,4);
 	pmat(cmat,1,8);
	videocursor(0,5,0); printf("a=%1u",t0);
	videocursor(0,5,4); printf("b=%1u",t1);
	videocursor(0,5,8); printf("c=%1u",t2);
	pmat(gmat,7,4);
	break;
    case '/': videoscroll(1,0,24,39,0,0); break;
    case '?': clard(); break;
    default: break;
    } /* end switch */
  }   /* end while  */
  videopalette(WHCYMAG);
  videomode(T80X25);
}

/* calculate the first two moments of all rules */
void allmo(stt,sta)
  double *stt, sta[5][K2+1][K2+1]; {
int tmat[KK][KK][KK][KK];
int umat[KK][KK][KK][KK];
int vmat[KK][KK][KK][KK];
int amat[KK][KK], bmat[KK][KK], cmat[KK][KK];
int ig, ih, hg[301];
int i, i0, i1, i2, i3, i4, i5, i6, i7, i8;
int t0, t1, t2;
double f, g, ff;
  i=0;
  videoscroll(1,0,24,39,0,0);
  for (i0=0;  i0<301; i0++)   hg[i0]=0;
  for (i0=10; i0<360; i0+=50) videodot( 99,i0,1);
  for (i0=10; i0<360; i0+=50) videodot(199,i0,1);
  for (i0=0; i0<KK; i0++) {if (kbdst()) break; binrule[0][0]=i0;
  for (i1=0; i1<KK; i1++) {if (kbdst()) break; binrule[0][1]=i1;
  for (i2=0; i2<KK; i2++) {if (kbdst()) break; binrule[0][2]=i2;
  for (i3=0; i3<KK; i3++) {if (kbdst()) break; binrule[1][0]=i3;
  for (i4=0; i4<KK; i4++) {if (kbdst()) break; binrule[1][1]=i4;
  for (i5=0; i5<KK; i5++) {if (kbdst()) break; binrule[1][2]=i5;
  for (i6=0; i6<KK; i6++) {if (kbdst()) break; binrule[2][0]=i6;
  for (i7=0; i7<KK; i7++) {if (kbdst()) break; binrule[2][1]=i7;
  for (i8=0; i8<KK; i8++) {if (kbdst()) break; binrule[2][2]=i8;
    zmat(amat);  djmat(amat,0);
    zmat(bmat);  djmat(bmat,1);
    zmat(cmat);  djmat(cmat,2);
    zzmat(tmat); tensq(tmat,amat,bmat,cmat);
    t0=tsum(amat);
    t1=tsum(bmat);
    t2=tsum(cmat);
    if (t0<=t1&&t1<=t2)
      {
      mmmat(vmat,tmat,tmat);
      mmmat(umat,tmat,vmat);
      mmmat(vmat,tmat,umat);
      ff=(double)ttsum(umat);
      f= (double)ttsum(vmat);
      g=f/ff;
      ig=(int)(300.0*((g-3.0)/6.0));
      hg[ig]++;
      ih=hg[ig]; if (ih>100) ih=100+ih/10;
      videodot(199-ih,10+ig,2);
      sta[0][t0][t1]+=1.0;
      sta[1][t0][t1]+=g; sta[2][t0][t1]+=g*g;
      if (sta[3][t0][t1]>=g) sta[3][t0][t1]=g;
      if (sta[4][t0][t1]<=g) sta[4][t0][t1]=g;
      if (g==3.0) *stt+=1.0;
      videocursor(0,10,20); printf("%5u %6.3f %1u %1u %1u",i,g,t0,t1,t2);
      }
    i++;
    }}}}}}}}}
  if (kbdst()) kbdin();
}

/* calculate tensor square axa+bxb+cxc */
void tensq(tmat,amat,bmat,cmat)
  int tmat[KK][KK][KK][KK];
  int amat[KK][KK], bmat[KK][KK], cmat[KK][KK]; {
int i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  tmat[i0][i1][i2][i3]+=amat[i0][i2]*amat[i1][i3];
  tmat[i0][i1][i2][i3]+=bmat[i0][i2]*bmat[i1][i3];
  tmat[i0][i1][i2][i3]+=cmat[i0][i2]*cmat[i1][i3];
  }
}

/* coefficients of characteristic equation */
void cheq(k,z) double k[4][2]; int z[KK][KK]; {
int t, p, d;
t=z[0][0]+z[1][1]+z[2][2];
p=z[0][0]*z[1][1]-z[0][1]*z[1][0];
p+=z[1][1]*z[2][2]-z[1][2]*z[2][1];
p+=z[2][2]*z[0][0]-z[2][0]*z[0][2];
d=z[0][0]*(z[1][1]*z[2][2]-z[1][2]*z[2][1]);
d+=z[0][1]*(z[1][2]*z[2][0]-z[1][0]*z[2][2]);
d+=z[0][2]*(z[2][1]*z[1][0]-z[1][1]*z[2][0]);
k[0][0]= 1.0;       k[0][1]=0.0;
k[1][0]=-(double)t; k[1][1]=0.0;
k[2][0]= (double)p; k[2][1]=0.0;
k[3][0]=-(double)d; k[3][1]=0.0;
}

/* clear edard screen and set up menu */
void clard() {
  videomode(COLGRAF);
  videopalette(YELREGR);
  videocursor(0,0,0);
  scrrul();
  videocursor(0,3,0);
  printf("counterimages\n\n");
  printf("abc - 0,1 matrix\n");
  printf("ABC - times abc \n");
  printf("=Xx - saved mtrx\n");
  printf("Tt  - tensor sq \n");
  printf("Q   - square    \n");
  printf("Ll  - eigenvalue\n");
  printf("h   - histogram \n");
  printf("j   - ancestors \n");
  printf("Ss   - all rules\n");
  printf("                \n");
  printf("?/   - hlp clr  \n");
  printf("<cr> - exit\n\n");
}

void rvers(amat,bmat,cmat) int amat[KK][KK], bmat[KK][KK], cmat[KK][KK]; {
int    m1[KK][KK][KK];
int    m2[KK][KK][KK][KK];
int    m3[KK][KK][KK][KK][KK];
int    m4[KK][KK][KK][KK][KK][KK];
int    i, i0, i1, i2, i3;
int    t1[KK], t2[KK][KK], t3[KK][KK][KK], t4[KK][KK][KK][KK];
double o, q, r, s, t, u, v, w, kk1, kk2, kk3, kk4, curt(), fort();

kk1=(double)K1;
kk2=(double)K2;
kk3=(double)K3;
kk4=(double)K4;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0][0][0],amat);
cymat(&m1[1][0][0],bmat);
cymat(&m1[2][0][0],cmat);
for (i0=0; i0<KK; i0++) t1[i0]=tsum(&m1[i0][0][0]);
videocursor(0,2,0); printf("%3u,%3u,%3u",t1[0],t1[1],t1[2]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  mmat(&m2[i0][i1][0][0],&m1[i0][0][0],&m1[i1][0][0]);
  t2[i0][i1]=tsum(&m2[i0][i1][0][0]);
  }
videocursor(0,4,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  printf("%3u,",t2[i0][i1]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {
  mmat(&m3[i0][i1][i2][0][0],&m1[i0][0][0],&m2[i1][i2][0][0]);
  t3[i0][i1][i2]=tsum(&m3[i0][i1][i2][0][0]);
  }
videocursor(0,6,0);
for (i0=0; i0<KK; i0++)
  {
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
    printf("%3u,",t3[i0][i1][i2]);
  printf("\n");
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  mmat(&m4[i0][i1][i2][i3][0][0],&m2[i0][i1][0][0],&m2[i2][i3][0][0]);
  t4[i0][i1][i2][i3]=tsum(&m4[i0][i1][i2][i3][0][0]);
  }
videocursor(0,10,0);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%3u,",t4[i0][i1][i2][i3]);
  printf("\n");
  }

q=r=s=0.0;
for (i=0; i<KK; i++) {t=((double)(t1[i]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk1); videocursor(0,20,0);  printf("%6.2f",t);
t=curt(r/kk1); videocursor(0,20,10); printf("%6.2f",t);
t=fort(q/kk1); videocursor(0,20,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
 {t=((double)(t2[i0][i1]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk2); videocursor(0,21,0);  printf("%6.2f",t);
t=curt(r/kk2); videocursor(0,21,10); printf("%6.2f",t);
t=fort(q/kk2); videocursor(0,21,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
  {t=((double)(t3[i0][i1][i2]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=u=sqrt(s/kk3); videocursor(0,22,0);  printf("%6.2f",t);
t=v=curt(r/kk3); videocursor(0,22,10); printf("%6.2f",t);
t=w=fort(q/kk3); videocursor(0,22,20); printf("%6.2f",t);

q=r=s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {t=((double)(t4[i0][i1][i2][i3]-AV)); o=t*t; s+=o; r+=o*t; q+=o*o;}
t=sqrt(s/kk4); videocursor(0,23,0);  printf("%6.2f",t);
s=1.0; if (u!=0.0) s=t/u;
videocursor(0,24,0); printf("r:%6.2f",s);
t=curt(r/kk4); videocursor(0,23,10); printf("%6.2f",t);
s=1.0; if (v!=0.0) s=t/v;
videocursor(0,24,12); printf("r:%6.2f",s);
t=fort(q/kk4); videocursor(0,23,20); printf("%6.2f",t);
s=1.0; if (w!=0.0) s=t/w;
videocursor(0,24,24); printf("r:%6.2f",s);

}

void histo(amat,bmat,cmat) int amat[KK][KK], bmat[KK][KK], cmat[KK][KK]; {
int    xmat[KK][KK];
int    m1[KK][KK][KK];
int    m2[KK][KK][KK][KK];
int    m4[KK][KK][KK][KK][KK][KK];
int    i, i0, i1, i2, i3, i4, i5, i6, i7;
int    t8[KK][KK][KK][KK][KK][KK][KK][KK];
int    po, da, h8[HH];
double s, t, kk8;

kk8=(double)K8;
videoscroll(1,0,24,39,0,0);
cymat(&m1[0][0][0],amat);
cymat(&m1[1][0][0],bmat);
cymat(&m1[2][0][0],cmat);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  mmat(&m2[i0][i1][0][0],
	&m1[i0][0][0],
	&m1[i1][0][0]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  mmat(&m4[i0][i1][i2][i3][0][0],
	&m2[i0][i1][0][0],
	&m2[i2][i3][0][0]);

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {
  mmat(xmat,
	&m4[i0][i1][i2][i3][0][0],
	&m4[i4][i5][i6][i7][0][0]);
  t8[i0][i1][i2][i3][i4][i5][i6][i7]=tsum(xmat);
  }

for (i0=0; i0<HH; i0++) h8[i0]=0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {i=t8[i0][i1][i2][i3][i4][i5][i6][i7]; if (i<HH) h8[i]++;}

po=da=0;
for (i=0; i<HH; i++)
  {
  i0=i%20;
  i1=i/20;
  po+=h8[i];
  da+=i*h8[i];
  videocursor(0,i0+1,13*i1+1);
  printf("%2u %4u %4u",i,h8[i],po);
  }

videocursor(0,22,0);  printf("ttl %4u in %4u pts;",AV*K8,K8);
videocursor(0,23,0);  printf("average: %2u",AV);
videocursor(0,22,23); printf("beyond:%5u,%3u",AV*K8-da,K8-po);

s=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
  {t=((double)(t8[i0][i1][i2][i3][i4][i5][i6][i7]-AV)); s+=t*t;}
t=sqrt(s/kk8);
videocursor(0,23,24); printf("sigma:   %6.2f",t);
s=1.0; if (t>1.0) s=exp(log(t)/8.0);
videocursor(0,24,0); printf("relative sigma:   %6.2f",s);

}

double curt(z) double z; {return exp(log(z)/3.0);}

double fort(z) double z; {return exp(log(z)/4.0);}

void rever() {
int brul[KK][KK], crul[KK][KK], drul[KK][KK][KK][KK];
int erul[KK][KK][KK][KK][KK][KK];
int i0,i1,i2,i3;
int j0,j1,j2,j3,j4,j5;
int k, l;
k=l=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
  {
  brul[0][0]=i0;
  brul[0][1]=i1;
  brul[1][0]=i2;
  brul[1][1]=i3;
  if (runiq(brul,crul)) {
    printf("%3d: ",++k);
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
    printf(" --- ");
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",crul[j0][j1]);
    printf("\n");
    }
  if (suniq(brul,drul)) {
    printf("%3d: ",++l);
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
    printf(" ---\n");
    for (j0=0; j0<KK; j0++)
      { 
      for (j1=0; j1<KK; j1++) 
      for (j2=0; j2<KK; j2++) for (j3=0; j3<KK; j3++)
	printf("%1d",drul[j0][j1][j2][j3]);
      printf("\n");
      } /* end for */
    }   /* end if  */
  if (tuniq(brul,erul)) {
    printf("%3d: ",++l);
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) printf("%1d",brul[j0][j1]);
    printf(" ---\n");
    for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++)
    for (j2=0; j2<KK; j2++)
      { 
      for (j3=0; j3<KK; j3++) 
      for (j4=0; j4<KK; j4++) for (j5=0; j5<KK; j5++)
	printf("%1d",erul[j0][j1][j2][j3][j4][j5]);
      printf("\n");
      } /* end for */
    }   /* end if  */
  }     /* end for nest */
}

int runiq(brul,crul) int brul[KK][KK], crul[KK][KK]; {
int a, b;
int j0, j1, j2;
for (j0=0; j0<KK; j0++) for (j1=0; j1<KK; j1++) crul[j0][j1]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  if (crul[a][b]==KK) crul[a][b]=j1;
  if (crul[a][b]!=j1) return(0);
  }
return(1);
}

int suniq(brul,drul) int brul[KK][KK], drul[KK][KK][KK][KK]; {
int a, b, e, f;
int j0, j1, j2, j3, j4;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
  drul[j0][j1][j2][j3]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  if (drul[a][b][e][f]==KK) drul[a][b][e][f]=j2;
  if (drul[a][b][e][f]!=j2) return(0);
  }
return(1);
}

int tuniq(brul,erul) int brul[KK][KK], erul[KK][KK][KK][KK][KK][KK]; {
int a, b, e, f, g, h;
int j0, j1, j2, j3, j4, j5, j6;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
  erul[j0][j1][j2][j3][j4][j5]=KK;
for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++)
for (j6=0; j6<KK; j6++) {
  a=brul[j0][j1];
  b=brul[j1][j2];
  e=brul[j2][j3];
  f=brul[j3][j4];
  g=brul[j4][j5];
  h=brul[j5][j6];
  if (erul[a][b][e][f][g][h]==KK) erul[a][b][e][f][g][h]=j3;
  if (erul[a][b][e][f][g][h]!=j3) return(0);
  }
return(1);
}

/* print matrix */
void pmat(z,i,j) int i, j, z[KK][KK]; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    {videocursor(0,i+i0,j+i1); printf("%1d",z[i0][i1]);}
}

/* print matrix */
void ppmat(z,i,j) int i, j, z[KK][KK][KK][KK]; {
int i0, i1, i2, i3;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
  {
  videocursor(0,i+KK*i0+i1,j);
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    printf("%4u",z[i0][i1][i2][i3]);
  }
}

/* display K4xK4 matrix */
void qqmat(z,i,j) int z[K4][K4], i, j; {
int i0, i1, k, l;
for (i0=0; i0<K4; i0++)
for (i1=0; i1<K4; i1++)
  {
  k=0; l=z[i0][i1];
  if (l==1) k=1;
  if (l>=2) k=2;
  if (l>=4) k=3;
  videodot(i+i0,j+i1,k);
  }
}

/* total matrix elements */
unsigned int tsum(z) int z[KK][KK]; {
int t, i0,i1;
  t=0;
    for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
        t+=z[i0][i1];
  return t;
}

/* total matrix elements */
unsigned int ttsum(z) int z[KK][KK][KK][KK]; {
int t, i0, i1, i2, i3;
  t=0;
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
      t+=z[i0][i1][i2][i3];
  return t;
}

/* count nonzero matrix elements */
unsigned int nzel(z) int z[KK][KK]; {
int t, i0,i1;
  t=0;
    for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
        if (z[i0][i1]!=0) t++;
  return t;
}

/* count nonzero matrix elements */
unsigned int nnzel(z) int z[KK][KK][KK][KK]; {
int t, i0, i1, i2, i3;
  t=0;
    for (i0=0; i0<KK; i0++)
    for (i1=0; i1<KK; i1++)
    for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
        if (z[i0][i1][i2][i3]!=0) t++;
  return t;
}

/* calculate row sums */
void rowsum(x,z) int x[KK], z[KK][KK]; {int i0, j0;
for (i0=0; i0<KK; i0++) {
  x[i0]=0;
  for (j0=0; j0<KK; j0++) x[i0]+=z[i0][j0];
  }
}

/* calculate column sums */
void colsum(x,z) int x[KK], z[KK][KK]; {int i0, j0;
for (j0=0; j0<KK; j0++) {
  x[j0]=0;
  for (i0=0; i0<KK; i0++) x[j0]+=z[i0][j0];
  }
}

/* copy one KKxKK matrix from another: z=x */
void cymat(z,x)
 int  z[KK][KK];
 int  x[KK][KK]; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z[i0][i1]=x[i0][i1];
}

/* copy one K2xK2 matrix from another: z=x */
void ccymat(z,x)
 int  z[KK][KK][KK][KK];
 int  x[KK][KK][KK][KK]; {
int i0, i1, i2, i3;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    z[i0][i1][i2][i3]=x[i0][i1][i2][i3];
}

/* multiply matrices */
void mmat(z,x,y) 
int z[KK][KK]; 
int x[KK][KK]; 
int y[KK][KK]; 
{
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z[i0][i2]+=x[i0][i1]*y[i1][i2];
      }
}

/* multiply transpose of first matrix by second */
void mtmat(z,x,y) 
int z[KK][KK]; 
int x[KK][KK]; 
int y[KK][KK]; 
{
int i0,i1,i2;
    for (i0=0; i0<KK; i0++)
    for (i2=0; i2<KK; i2++)
      {
      z[i0][i2]=0;
      for (i1=0; i1<KK; i1++) z[i0][i2]+=x[i1][i0]*y[i1][i2];
      }
}

/* multiply matrices */
void mmmat(z,x,y) 
int z[KK][KK][KK][KK];
int x[KK][KK][KK][KK];
int y[KK][KK][KK][KK];
{
int i0, i1, i2, i3, i4, i5;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    for (i4=0; i4<KK; i4++)
    for (i5=0; i5<KK; i5++)
      {
      z[i0][i1][i4][i5]=0;
      for (i2=0; i2<KK; i2++)
      for (i3=0; i3<KK; i3++)
	z[i0][i1][i4][i5]+=x[i0][i1][i2][i3]*y[i2][i3][i4][i5];
      }
}

/* multiply transpose of first K2xK2 matrix by second */
void mmtmat(z,x,y) 
int z[K2][K2]; 
int x[K2][K2]; 
int y[K2][K2]; 
{
int i0,i1,i2;
    for (i0=0; i0<K2; i0++)
    for (i2=0; i2<K2; i2++)
      {
      z[i0][i2]=0;
      for (i1=0; i1<K2; i1++) z[i0][i2]+=x[i1][i0]*y[i1][i2];
      }
}

/* generate the de Bruijn fragment evolving to l in matrix z */
void djmat(z,l) int l, z[KK][KK]; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z[i0][i1]=(binrule[i0][i1]==l)?1:0;
}

/* zero a KKxKK matrix */
void zmat(z) int  z[KK][KK]; {
int i0,i1;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z[i0][i1]=0;
}

/* generate a K2xK2 unit matrix */
void unmat(z) int  z[KK][KK][KK][KK]; {
int i0, i1;
  zzmat(z);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
    z[i0][i1][i0][i1]=1;
}

/* zero a K2xK2 matrix */
void zzmat(z) int  z[KK][KK][KK][KK]; {
int i0, i1, i2, i3;
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
    z[i0][i1][i2][i3]=0;
}

/* average and variance of eigenvector components */

void auua(ave,var,ex,wy,cve,vec,mat)
 double *ave, *var, *ex, *wy, *cve, *vec;
 int mat[K2][K2]; {
int    i, j;
double a, v, p, q, r, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat[j][i];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
for (i=0; i<K2; i++) vec[i]/=a;
a=1.0/kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
for (p=q=r=0.0, i=0; i<K2; i++)
  {
  p+=cve[i]*vec[i];
  q+=cve[i]*cve[i];
  r+=vec[i]*vec[i];
  }
*ave=a;
*var=sqrt(v/kk2);
*ex=0.0; if(q*r>0.0) *ex=p/sqrt(q*r);
*wy=p;
}

/* average and variance of column sums */

void avva(ave,var,vec,mat) double *ave, *var, *vec; int mat[K2][K2]; {
int    i, j;
double a, v, kk2;
kk2=(double)K2;
for (i=0; i<K2; i++)
for (vec[i]=0.0, j=0; j<K2; j++)
  vec[i]+=(double)mat[i][j];
for (a=0.0, i=0; i<K2; i++) a+=vec[i];
a/=kk2;
for (i=0; i<K2; i++) vec[i]-=a;
for (v=0.0, i=0; i<K2; i++) v+=vec[i]*vec[i];
*ave=a;
*var=sqrt(v/kk2);
}


/* end  nxardn32.c */
