
/* nxlcau32.h			*/
/* header for nxlcau32.c	*/
/* 5 October 1989		*/

# define COLGRAF     4  /* graph resolution			*/
# define T80X25      3  /* text resolution			*/
# define WHCYMAG     1  /* color quad for normal screen		*/
# define YELREGR     2  /* color quad for alternative screen	*/
# define CR		        5  /* cursor reference - row editor	*/
# define CM		        7  /* cursor reference - main menu	*/
# define CL		       11  /* cursor reference - line editor	*/
# define TRR	    16  /* row showing totalistic rule number	*/
# define TRC	    56  /* column for totalistic rule number	*/
# define XRR	    12  /* row displaying totalistic rule	*/
# define XRC	    56  /* column for totalistic rule		*/
# define AL      16384  /* array length (screen width)		*/
# define SL	    40	/* short array length			*/
# define YL        320  /* array length (screen width)		*/
# define TS	    11	/* distinct sums w/totalistic rule	*/
# define SS	     8  /* distinct sums semitotalistic rule    */
# define DS	   243  /* (number of distinct neighborhoods)	*/
# define KK	     3  /* number of states per cell		*/
# define RR	     5  /* length of neighborhood = 2r+1	*/ 
# define DN (KK*KK*KK*KK)	/* number of distinct nodes	*/
# define PDN     81*81	/* nodes in pair diagram = KK^4r	*/
# define SDN      4096	/* nodes in subset diagram = 2^(KK^2r)	*/
# define DDN	  6561	/* maximum nodes de Bruijn diagram	*/
# define QDN	   128	/* maximum nodes 2-D de Bruijn diagram	*/
# define QWN	   128  /* node list 2-D de Bruijn node & link  */
# define BD	    31  /* maximum degree of b.p.		*/

# define RSYM		12	/* number of rule symmetries = 2*k!	*/
# define WNML	        82	/* arry size for base 27 wolfram number */

# define CCY          6		/* circumference of max length cycle	*/
# define XCY	    729		/* max number of cycles = KK^CCY	*/

# define XAN	     52		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define AV	(KK*KK)
# define HH	60		/* points in histogram */

# define CLEN 300	/* buffer length for rec source     */
# define PLEN 900	/* buffer length for rec object     */
# define XLEN 128	/* buffer length for rec predefined */
# define NY    24

typedef union birular {
		int one[KK*KK*KK*KK*KK]; 
		int five[KK][KK][KK][KK][KK];
		} birular;
typedef union parneih {
		int one[K4*K4];
		int two[K4][K4];
	 	int eight[KK][KK][KK][KK][KK][KK][KK][KK];
		} parneih;
typedef union twoparn {
		int one[K8*K8];
		int two[K8][K8]; 
		int four[K4][K4][K4][K4];
		int 
    sixteen[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
		} twoparn;

/* end nxlcau32.h*/
