
/* ---------------------------------------------------- */
/* ruin4h.c						*/
/* ---------------------------------------------------- */
/* program for q4hil option 'd'				*/
/* display de Bruijn diagram - 1st, 2nd, & 3rd gen	*/
/* Harold V. McIntosh, 20 February 1988			*/
/* 21 February 1988 - add j0=i0; to Pass 4's [HVM]	*/
/* 12 August 1988 - adaptation for squl.c [HVM]		*/
/* 24 October 1989 - adaptation for r = 1/2		*/
/* 20 November 1989 - removed loop from kwait		*/
/* 10 July 1992 - adapted for CAMEX			*/
/* ---------------------------------------------------- */

// # include "camex.h"
// # include "keybrd.h"
# include <stdio.h>

# define  QL   48  /* dim of array for sample (even)	*/
# define MM   256  /* maximum number of links		*/
# define NO    16  /* square root of MM = # nodes	*/
# define OO    64  /* maximum number of strips		*/
# define  XC    3  /* maximum strip length		*/
# define AUR  148  /* matrix u.l. row (from bottom)	*/
# define AUC   20  /* matrix u.l. col (graf)		*/
# define HER    3  /* header u.l. row			*/
# define HEC   14  /* header u.l. col			*/
# define PER    4  /* help   u.l. row			*/
# define PEC   25  /* help   u.l. col			*/
# define TMR    6  /* matrix u.l. row (text)		*/
# define TMC    2  /* matrix u.l. col			*/
# define TTR    6  /* table u.l. row (text)		*/
# define TTC   20  /* table u.l. col			*/

extern FILE *P0;

# define PM	2  /* cells in 1-g partial neighborhood	*/
# define QM	2  /* cells in 1-g fringe neighborhood	*/

extern char qharule[K2][K2][K2][K2];	/* (4,1/2) general rule			    */

/* -------------------------- */
/* edit the de Bruijn diagram */
/* -------------------------- */

edijn4h() {
int  aa[K2][K2][K2][K2];
int  bb[K2][K2][K2][K2];
char cc[QL][QL];		/* cell array for editor      */
int  dd[OO][OO];
int  dk;			/* write matrix on disk	      */
char c;

grfmode();
videocursor(0,0,5); tidat();
videocursor(0,23,0); printf("%8u",coreleft());
clijn4h();
dk=0;

while (0<1) {
/*  rmenu(); */
/*  scrrul(UROW,UCOL); */
  videocursor(0,0,0); videoputc('d',1);
  videocursor(0,0,2); videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,1); videoputc(c,2);
  videocursor(0,0,2); videoputc(' ',2);
  videocursor(0,0,5); tidat();
  videocursor(0,5,0);
  switch (c) {

    case 'a': scrstr("upper left:  "); apass1(aa,0); amcopy(bb,aa); break;
    case 'b': scrstr("upper right: "); apass1(aa,1); amcopy(bb,aa); break;
    case 'c': scrstr("lower left:  "); apass1(aa,2); amcopy(bb,aa); break;
    case 'd': scrstr("lower right: "); apass1(aa,3); amcopy(bb,aa); break;
    case 'e': scrstr("zeroes:      "); apass1(aa,4); amcopy(bb,aa); break;
    case 'f': scrstr("ones:        "); apass1(aa,5); amcopy(bb,aa); break;
    case 'g': scrstr("twos:        "); apass1(aa,6); amcopy(bb,aa); break;
    case 'h': scrstr("threes:      "); apass1(aa,7); amcopy(bb,aa); break;

    case 'i': cledi('m'); prng(1); break;
    case 'k': dk=1; break;
    case 'K': dk=0; break;
    case 'm': cledi('m'); aprnz(aa); aprnd(aa); break;
    case 'n': cledi('m'); aprnz(bb); aprnd(bb); break;
    case 'o': cledi('m'); bprnz(dd); break;
    case 's': sstep(); margrp(); break;
    case 'S': margnh(0); while (!kbdst()) {sstep(); margrp();} kbdin(); break;
    case 't': cledi('m'); astrp(aa,bb); break;
    case 'z': cledi('m'); break;
    case 'Z': cledi('x'); break;
    case '8': aeipo(aa,bb); break;

    case 'A': apass7(dd,bb,1,1,dk); break;
    case 'B': apass7(dd,bb,2,1,dk); break;
    case 'C': apass7(dd,bb,3,1,dk); break;
    case 'D': apass7(dd,bb,4,1,dk); break;

    case 'M': apass7(dd,bb,1,0,dk); break;
    case 'N': apass7(dd,bb,2,0,dk); break;
    case 'O': apass7(dd,bb,3,0,dk); break;
    case 'P': apass7(dd,bb,4,0,dk); break;

    case '1': afilp(dd,cc,1); cafilp(dd,1); break;
    case '2': afilp(dd,cc,2); cafilp(dd,2); break;
    case '3': afilp(dd,cc,3); cafilp(dd,3); break;
    case '4': afilp(dd,cc,4); cafilp(dd,4); break;

    case 'x': dbhonegen(cc); frayme(); ascreen(cc); break;
    case 'X':
	 frayme();
	 while (!kbdst()) {dbhonegen(cc); ascreen(cc);} 
	 kbdin();
	 break;

    case 'u': margnh(0); break;
    case 'v': sstep(); break;

    case '=': videocursor(0,6,0); apass4(bb); break;

    case '?': case '/': clijn4h(); break;

    default: break;
    }	/* end switch */
  }	/* end while  */

grfmode();

}	/* end edijn4h */

/* clear space for the matrix */
clmat() {videoscroll(6,0,24,24,0,0);}

/* clear edijn screen and set up menu */

clijn4h() {
videoscroll(6,25,24,39,0,0);
  videocursor(0,7,27);  scrstr("abcdef-shifts");
  videocursor(0,8,27);  scrstr("ABC   -strips");
  videocursor(0,9,27);  scrstr("MNO    -0,0's");
  videocursor(0,10,27); scrstr("=-type matrix");
  videocursor(0,11,27); scrstr("g-matrix grid");
  videocursor(0,12,27); scrstr("m-grph matrix");
  videocursor(0,13,27); scrstr("t-mtrx power");
  videocursor(0,14,27); scrstr("8-survey 1-9");
  videocursor(0,15,27); scrstr("/,z-clr scrn");
  videocursor(0,16,27); scrstr("Z-clear all");
  videocursor(0,17,27); scrstr("<cr> - exit");
}

/* ONE4H.C */

/* Pass 1 marks sequences conforming to some shift */
apass1(aa,l) int aa[K2][K2][K2][K2]; int l; {
int  i0, i1, i2, i3;
int  k, m;
for (i0=0; i0<K2; i0++)
for (i1=0; i1<K2; i1++)
for (i2=0; i2<K2; i2++)
for (i3=0; i3<K2; i3++)
  {
  k=qharule[i0][i1][i2][i3];
  switch (l) {
    case 0: m=i0; break;
    case 1: m=i1; break;
    case 2: m=i2; break;
    case 3: m=i3; break;
    case 4: m=0;  break;
    case 5: m=1;  break;
    case 6: m=2;  break;
    case 7: m=3;  break;
    default: break;}
  aa[i0][i1][i2][i3]=k==m?1:0;
  aadot(i2*K2+i3,i0*K2+i1,k==m?1:2);
  }
}

/* pass 4 - print the matrix elements of the connection matrix */

apass4(z) int z[K2][K2][K2][K2]; {
int  i0, i1, i2, i3;
for (i0=0; i0<K2; i0++)
for (i1=0; i1<K2; i1++) {
  for (i2=0; i2<K2; i2++)
  for (i3=0; i3<K2; i3++) {
    if (z[i0][i1][i2][i3]!=0) 
       printf("%1d%1d, ",i0*K2+i1,i2*K2+i3);
    }
    printf("\n");
    }
}

/* apass7 - get the loops of length l			*/
/* t = 0: loops through (0,0), t = 1: all loops		*/
/* oc is used to mark links while locating pure loops.	*/
/* 4 indicates a viable link, add 1 for in link, 2 for	*/
/* out link. Thus links marked 7 survive until the next	*/
/* round, then get marked 4, all else 0. Repeat until	*/
/* no 5's or 6's show.					*/

apass7(dd,bb,l,t) int dd[OO][OO], *bb; int l, t; {
int  f, g, k, p, q, no, lk;
char tc[MM];
if (l>XC) return;
cledi('t');
videocursor(0,5,14); printf("width %1d.",l);
videocursor(0,7,25); printf("gen nodes links");
for (p=0; p<MM; p++) tc[p]=4;
k=0;
do {
  g=0; k++; no=0; lk=0;
  cledi('m');
  apass7x(dd,bb,tc,&lk,l,0,t);
  for (p=0; p<MM; p++) {
    f=tc[p];
    if (f==7) no++;
    if (f==5||f==6) g=1;
    tc[p]=f==7?4:0;
    }
  videocursor(0,8+k%16,25); printf("%3d %5d %5d",k,no,lk);
  } while (g==1);
videocursor(0,24,0);
/* apass7x(dd,bb,tc,&lk,l,3,t); */
if (l<=XC) {
  for (p=0; p<OO; p++) for (q=0; q<OO; q++) dd[p][q]=-1;
  apass7x(dd,bb,tc,&lk,l,4,t);
  return;
  }
if (l<XC+2) {
  g=4;
  for (p=0; p<OO; p++) for (q=0; q<OO; q++) dd[p][q]=(dd[p][q]==4)?g++:-1;
  videoscroll(6,7,24,24,0,0);
  apass7x(dd,bb,tc,&lk,l,2,t);
  return;
  }
}

/* apass 7x - display the acceptable strings of length l */
/* s = 0,1,2,3 display mode; t = 0,1 (0,0) vs general	*/

apass7x(dd,bb,tc,lk,l,s,t)  int *dd, *bb; char *tc; int *lk; int l, s, t; {
char i[PM], j[PM], r[QM][10];
int  p;
if (l<1) return;
switch (t) {
  case 0:
    if (l>XC+2) return;			/* string length up to 7 */
    for (p=0; p<PM; p++) i[p]=j[p]=0;
    apass7a(dd,bb,tc,lk,r,i,j,0,l,s);
    break;
  case 1:
    if (l>XC) return;			/* general strings take more space */
    for (i[0]=0; i[0]<K2; i[0]++) {
    for (i[1]=0; i[1]<K2; i[1]++) {
      for (p=0; p<PM; p++) j[p]=i[p];
      apass7a(dd,bb,tc,lk,r,i,j,0,l,s);
      }}
    break;
  default: break;
  }
}

/* apass 7a - recursive step in pass 7 */

apass7a(dd,bb,tc,lk,r,i,j,k,l,s)
int  dd[OO][OO];
int  bb[K2][K2][K2][K2];
char tc[MM];
int  *lk;
char *i, *j;
int  k, l, s;
char r[QM][10];
{
int p, w, x, i0, i1, j0, j1;
if (k<l) {
  j0=j[0]; j1=j[1];
  for (i0=0; i0<K2; i0++) {r[0][k]=i0;
  for (i1=0; i1<K2; i1++) {r[1][k]=i1;
    if (bb[j0][i0][j1][i1]) {
      j[0]=i0; j[1]=i1;
      apass7a(dd,bb,tc,lk,r,i,j,k+1,l,s);}
    }}
  return;}
for (p=0; p<PM; p++) if (i[p]!=j[p]) return;
for (p=0, w=0; p<l; p++) w=w*K2+r[0][p];
for (p=0, x=0; p<l; p++) x=x*K2+r[1][p];
if ((tc[w] >= 4) && (tc[x] >= 4)) {
  switch (s) {
    case 0: /* record in's and out's */
      adot(2*w,2*x,1); adot(2*w+1,2*x+1,1); tc[w]|=1;
      adot(2*w+1,2*x,2); adot(2*w,2*x+1,2); tc[x]|=2;
      (*lk)++; break;
    case 1: /* graph and linkage matrix - full numbering */
      adot(2*w,2*x,3); adot(2*w+1,2*x+1,3);
      adot(2*w+1,2*x,3); adot(2*w,2*x+1,3);
      break;
    case 2: /* graph w/o linkage matrix */
      adot(w,x,3);
      break;
    case 3: /* print links on screen */
      printf("      ");
      if (l>1) for (p=0; p<l-1; p+=2)
        printf("%1.1X",((r[0][p]*K2+r[1][p])*K2+r[0][p+1])*K2+r[1][p+1]);
      if (l%2==1) printf("%1.1X",r[0][l-1]*K2+r[1][l-1]); printf(" ");
      for (p=0; p<l; p++) printf("%1.1d",r[0][p]); printf(" ");
      for (p=0; p<l; p++) printf("%1.1d",r[1][p]); printf("\n");
      break;
    case 4: /* fill out dd[w][x] */
      dd[w][x]=w+OO*x;
      break;
    default: break;
  }} 
}

/* print the diagonal of the 2x2 array z */
aprnd(z) int z[K2][K2][K2][K2]; {
int i, j, k, l, i0, i1;
l=0;
for (i0=0; i0<K2; i0++) {
for (i1=0; i1<K2; i1++) {
    i=i0+i1*K2;
    k=z[i0][i1][i0][i1];
    l+=k;
    j=k==0?1:3;
    aadot(i,i,j);
  }}
  videocursor(0,1,10); printf("%8u",z[0][0][0][0]);
  videocursor(0,1,20); printf("%8u",l);
}

/* show the outline of the 2x2 array z as dots on the videoscreen */
/* that is, set up a grid with double spaced dots of color l	  */
aprng(l) int l;{
int i0, i1;
int j0, j1;
int i, j;
for (i0=0; i0<K2; i0++) {
for (i1=0; i1<K2; i1++) {
  for (j0=0; j0<K2; j0++) {
  for (j1=0; j1<K2; j1++) {
    i=j0+j1*K2;
    j=i0+i1*K2;
    adot(2*i,2*j,l);
    }}
  }}
}

/* show the array z as a set of dots on the videoscreen */
aprnz(z) int z[K2][K2][K2][K2]; {
int i0, i1;
int j0, j1;
int i, j, k;
for (i0=0; i0<K2; i0++)
for (i1=0; i1<K2; i1++)
  for (j0=0; j0<K2; j0++)
  for (j1=0; j1<K2; j1++) {
    i=j0+K2*j1;
    j=i0+K2*i1;
    k=z[i0][i1][j0][j1];
    if (k==0)  bbdot(i,j,1); else aadot(i,j,3);
    }
}

/* show the array z as a set of dots on the videoscreen */
bprnz(z) int z[OO][OO]; {
int i0, i1;
for (i0=0; i0<OO; i0++) for (i1=0; i1<OO; i1++)
  if (z[i0][i1]==-1) bbdot(i0,i1,1); else aadot(i0,i1,3);
}

/* bb becomes next power, display matrix and diagonal */
astrp(aa,bb) int *bb; {int x[K2][K2][K2][K2];
amcopy(x,bb);
amprod(bb,x,aa);
aprnz(x);
aprnd(x);
}

/* calculate traces and (0,0) elements for first 9 powers of aa */
aeipo(aa,bb) int *aa, *bb; {
int  i, azzel();
int  x[K2][K2][K2][K2];
long int atraz();
cledi('t');
videocursor(0,TTR-2,TTC); printf("isolated cyclic");
videocursor(0,TTR,TTC); printf("%6u",azzel(aa)); printf(",%8lu",atraz(aa));
for (i=0; i<6; i++) {
  amcopy(x,bb);
  amprod(bb,x,aa);
  videocursor(0,TTR+1+i,TTC); printf("%6u",azzel(bb)); printf(",%8lu",atraz(bb));
  }
}

/* multiply two 2x2 matrices */
amprod(z,x,y)
int x[K2][K2][K2][K2];
int y[K2][K2][K2][K2];
int z[K2][K2][K2][K2];
{
int i0, i1;
int j0, j1;
int k0, k1;

for (i0=0; i0<K2; i0++)
for (i1=0; i1<K2; i1++)

for (k0=0; k0<K2; k0++)
for (k1=0; k1<K2; k1++) {

  z[i0][i1][k0][k1]=0; 

  for (j0=0; j0<K2; j0++)
  for (j1=0; j1<K2; j1++) {

    z[i0][i1][k0][k1]+= 
    x[i0][i1][j0][j1]*
    y[j0][j1][k0][k1];

      }
    }
}

/* copy one 2x2 array to another */
amcopy(z,x)
int z[K2][K2][K2][K2];
int x[K2][K2][K2][K2];
{
int i0, i1;
int j0, j1;

for (i0=0; i0<K2; i0++)
for (i1=0; i1<K2; i1++)

  for (j0=0; j0<K2; j0++)
  for (j1=0; j1<K2; j1++)

    z[i0][i1][j0][j1]=x[i0][i1][j0][j1];

}

/* calculate the 0,0 element of z */
int azzel(z) int z[K2][K2][K2][K2]; {return z[0][0][0][0];}

/* calculate the trace of z */
long int atraz(z) int z[K2][K2][K2][K2]; {
int i0, i1;
long int k;
k=0;
for (i0=0; i0<K2; i0++)
for (i1=0; i1<K2; i1++)
  k+=z[i0][i1][i0][i1];
return k;
}

/* display a screen of evolution */
ascreen(z) char z[QL][QL]; {int i0, i1;
  for (i0=0; i0<QL; i0++)
  for (i1=0; i1<QL; i1++)
    aadot(i0+1,i1+1,z[i0][i1]);
}

/* fill the field with a configuration of periodicity obtained	*/
/* with the help of a de Bruijn diagram.			*/
/* dd is a connectivity matrix with FF's and coded nodes	*/
/* cc is an array for the sample configuration			*/
/* if (n==0) {screen(cc); printf("%3d",i); return;}		*/

afilp(dd,cc,l) int *dd; char cc[QL][QL]; int l; {
int x[OO*OO], y[OO], z[XC];
int i0, j0, i, j, k, m, n;
cledi('m');
alnze(x,&n,dd);
videocursor(0,1,34); printf("%5d",n);
if (n==0) return;
i=rand()%n; m=x[i]; i0=m/OO; j0=m%OO; m=dd[m]; 
aecox(z,m%OO,l); for (k=0; k<QL; k++) cc[QL/2][k]=z[k%l];
aecox(z,m/OO,l); for (k=0; k<QL; k++) cc[QL/2+1][k]=z[k%l];
i=j0;
for (j=QL/2+2; j<QL; j++) {
  alnzr(y,&n,dd,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=dd[i]/OO; i%=OO;
  aecox(z,m,l); for (k=0; k<QL; k++) cc[j][k]=z[k%l];
  }
i=i0;
for (j=QL/2-1; j>=0; j--) {
  alnzc(y,&n,dd,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=dd[i]%OO; i/=OO;
  aecox(z,m,l); for (k=0; k<QL; k++) cc[j][k]=z[k%l];
  }
frayme();
ascreen(cc);
}

/* locate and count the nonzero elements of the rth row of dd */
alnzr(x,n,dd,r)  int dd[OO][OO]; int x[OO]; int *n, r; {int i, m;
for (i=0, m=0; i<OO; i++) if (dd[r][i]!=-1) {x[m]=i+r*OO; m++;} 
*n=m;}

/* locate and count the nonzero elements of a column of dd */
alnzc(x,n,dd,c)  int dd[OO][OO]; int x[OO]; int *n, c; {int i, m;
for (i=0, m=0; i<OO; i++) if (dd[i][c]!=-1) {x[m]=c+i*OO; m++;}
*n=m;}

/* locate and count the nonzero elements within the matrix dd */
alnze(x,n,dd)  int dd[OO][OO]; int x[OO*OO]; int *n; {int i, j, m;
m=0; for (i=0; i<OO; i++) for (j=0; j<OO; j++) 
  if (dd[i][j]!=-1) {x[m]=j+i*OO; m++;}
*n=m;}

/* decompose an index n into a series of l cell values */
aecox(x,n,l) int x[XC]; int n, l; {int i;
for (i=0; i<l; i++, n/=K2) x[l-i-1]=n%K2;}

/* fill CAM bitplanes 0 and 1 with a configuration whose   */
/* periodicity has been obtained from a de Bruijn diagram. */
/* dd is a connectivity matrix with FF's and coded nodes   */
/* cc is an array for the sample configuration		   */
/* l is the length of the vertical strip to be inserted    */

cafilp(dd,l) int *dd; int l; {
char cc[CL];
int  x[OO*OO], y[OO], z[XC];
int  i0, j0, i, j, k, m, n;
alnze(x,&n,dd);
videocursor(0,1,34); printf("%5d",n);
if (n==0) return;
wait();
pnotv();
i=rand()%n; m=x[i]; i0=m/OO; j0=m%OO; m=dd[m]; 
aecox(z,m%OO,l);
for (k=0; k<CL/2; k++) cc[CL-1-2*k]=cc[CL-1-2*k-1]=z[k%l]%KK;
writrow(cc,CL/2-2,0x01); writrow(cc,CL/2-1,0x01);
for (k=0; k<CL/2; k++) cc[CL-1-2*k]=cc[CL-1-2*k-1]=z[k%l]/KK;
writrow(cc,CL/2-2,0x02); writrow(cc,CL/2-1,0x02);
aecox(z,m/OO,l);
for (k=0; k<CL/2; k++) cc[CL-1-2*k]=cc[CL-1-2*k-1]=z[k%l]%KK;
writrow(cc,CL/2,0x01); writrow(cc,CL/2+1,0x01);
for (k=0; k<CL/2; k++) cc[CL-1-2*k]=cc[CL-1-2*k-1]=z[k%l]/KK;
writrow(cc,CL/2,0x02); writrow(cc,CL/2+1,0x02);
i=j0;
for (j=0; j<CL/4-1; j++) {
  alnzr(y,&n,dd,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=dd[i]/OO; i%=OO;
  aecox(z,m,l);
  for (k=0; k<CL/2; k++) cc[CL-1-2*k]=cc[CL-1-2*k-1]=z[k%l]%KK;
  writrow(cc,CL/2+2+2*j,0x01); writrow(cc,CL/2+3+2*j,0x01);
  for (k=0; k<CL/2; k++) cc[CL-1-2*k]=cc[CL-1-2*k-1]=z[k%l]/KK;
  writrow(cc,CL/2+2+2*j,0x02); writrow(cc,CL/2+3+2*j,0x02);
  }
i=i0;
for (j=0; j<CL/4-1; j++) {
  alnzc(y,&n,dd,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=dd[i]%OO; i/=OO;
  aecox(z,m,l);
  for (k=0; k<CL/2; k++) cc[CL-1-2*k]=cc[CL-1-2*k-1]=z[k%l]%KK;
  writrow(cc,CL/2-4-2*j,0x01); writrow(cc,CL/2-3-2*j,0x01);
  for (k=0; k<CL/2; k++) cc[CL-1-2*k]=cc[CL-1-2*k-1]=z[k%l]/KK;
  writrow(cc,CL/2-4-2*j,0x02); writrow(cc,CL/2-3-2*j,0x02);
  }
gotv();
}

/* cfillp modified to insert a left margin for each column */

cmafilp(dd,l) int *dd; int l; {
char cc[CL];
int  x[OO*OO], y[OO], z[XC];
int  i0, j0, i, j, k, m, n;
wait();
pnotv();
alnze(x,&n,dd);
videocursor(0,1,34); printf("%5d",n);
if (n==0) return;
i=rand()%n; m=x[i]; i0=m/OO; j0=m%OO; m=dd[m]; 
aecox(z,m%OO,l);
for (k=0; k<100; k++) cc[k]=0;
for (k=100; k<100+l; k++) cc[k]=z[k-100];
for (k=100+l; k<CL; k++) cc[k]=1;
writrow(cc,CL/2,0x01);
aecox(z,m/OO,l);
for (k=0; k<100; k++) cc[k]=0;
for (k=100; k<100+l; k++) cc[k]=z[k-100];
for (k=100+l; k<CL; k++) cc[k]=1;
writrow(cc,CL/2-1,0x01);
i=j0;
for (j=CL/2-2; j>=0; j--) {
  alnzr(y,&n,dd,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=dd[i]/OO; i%=OO;
  aecox(z,m,l);
for (k=0; k<100; k++) cc[k]=0;
for (k=0; k<l; k++) cc[100+k]=z[k];
for (k=100+l; k<CL; k++) cc[k]=1;
writrow(cc,j,0x01);
  }
i=i0;
for (j=CL/2+1; j<CL; j++) {
  alnzc(y,&n,dd,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=dd[i]%OO; i/=OO;
  aecox(z,m,l);
for (k=0; k<100; k++) cc[k]=0;
for (k=0; k<l; k++) cc[100+k]=z[k];
for (k=100+l; k<CL; k++) cc[k]=1;
writrow(cc,j,0x01);
  }
margnh(0);
gotv();
}

/* ------------------------------------- */

/* calculate one generation of evolution */
/* of (4,1/2) Moore automaton for ruin4h */
dbhonegen(a) char a[QL][QL]; {
char b[QL][QL];
int  a0, a1, a2, a3;
int  i0, i1;
  for (i0=0; i0<QL; i0++)
  for (i1=0; i1<QL; i1++) {
    a0=a[i0][i1];
    a2=a[i0][(QL+i1+1)%QL];
    a1=a[(QL+i0+1)%QL][i1];
    a3=a[(QL+i0+1)%QL][(QL+i1+1)%QL];
    b[i0][i1]=qharule[a0][a1][a2][a3];
    }
  for (i0=0; i0<QL; i0++)
  for (i1=0; i1<QL; i1++) a[i0][i1]=b[i0][i1];
}

/* end ruin4h.c */
